<?php

/**
 * webstats page
 *
 * @package Webstats.common
 * @author rio
 * @version 0.0.1
 * @copyright Copyright (C) Sergio Rizzi
 */
class webstatscommon {
	/**
	 * @var int class version
	 */
	public $version = '0.0.1';

	/**
	 * constructor
	 */
	function webstatscommon() {
		$this->webstats_seestats();
	}

	/***** FUNCTIONS *****/

	public function webstats_seestats () {
		global $webstats, $webstats_txt, $inetd;

		$first = true;
		$first_date = "";
		$tot_visit = 0;
		
		$now = date("Y-m-d");
		$most_visit_day = "";
		$numpages_most_visit_day = -1;
		$less_visit_day = "";
		$numpages_less_visit_day = -1;
		
		$days = array();
		$days[0] = 0;
		$days[1] = 0;
		$days[2] = 0;
		$days[3] = 0;
		$days[4] = 0;
		$days[5] = 0;
		$days[6] = 0;
		$day_most = "";
		$day_most_visit = -1;
		$day_less = "";
		$day_less_visit = -1;
		
		$mons = array();
		$mons[0] = 0;
		$mons[1] = 0;
		$mons[2] = 0;
		$mons[3] = 0;
		$mons[4] = 0;
		$mons[5] = 0;
		$mons[6] = 0;
		$mons[7] = 0;
		$mons[8] = 0;
		$mons[9] = 0;
		$mons[10] = 0;
		$mons[11] = 0;
		
		$ie = 0;
		$moz = 0;
		$opera = 0;
		$safari = 0;
		$brow_unknown = 0;
		$win = 0;
		$lin = 0;
		$mac = 0;
		$bsd = 0;
		$sun = 0;
		$so_unknown = 0;
		
		$request = _ISI_DBQUERY("SELECT visits from ".$webstats["table"]["visits"]." ORDER BY `date` DESC LIMIT 1, 2");
		$yesterday = $request[0]["visits"];
		if (!is_numeric($yesterday)) $yesterday = 0;
		$query = "SELECT * from ".$webstats["table"]["visits"]." ORDER BY date ASC";
		$row = _ISI_DBQUERY($query);
		for ($i=0;$i < count($row); $i++) {
		 $visits = $row[$i]["visits"];
		 $tot_visit += $visits;
		 $date = $row[$i]["date"];
		 $day = $row[$i]["day"];
		 $mon = $row[$i]["month"];
		 $yeartmp = substr($row[$i]["date"], 0, 4);
		
		 /*switch ($yeartmp) {
		  case '2006':
		   $years[0][1] = $years[0][1] + $visits;
		   break;
		  case '2007':
		   $years[1][1] = $years[1][1] + $visits;
		   break;
		 }*/
		
		 if ($first) {
		  $first_date = $date;
		  $first = false;
		  $startyear = $yeartmp;
		 }
		 if ($date == $now) $tot_today = $visits;
		
		 if (($numpages_most_visit_day == -1 || $visits > $numpages_most_visit_day)) {
		  $most_visit_day = $date;
		  $numpages_most_visit_day = $visits;
		 }
		
		 if (($numpages_less_visit_day == -1 || $visits < $numpages_less_visit_day) && $date != $now) {
		  $less_visit_day = $date;
		  $numpages_less_visit_day = $visits;
		 }
		
		 if ($day == "Mon") $days[0] += $visits;
		 if ($day == "Tue") $days[1] += $visits;
		 if ($day == "Wed") $days[2] += $visits;
		 if ($day == "Thu") $days[3] += $visits;
		 if ($day == "Fri") $days[4] += $visits;
		 if ($day == "Sat") $days[5] += $visits;
		 if ($day == "Sun") $days[6] += $visits;
		
		 if ($mon == "Jan") $mons[0] += $visits;
		 if ($mon == "Feb") $mons[1] += $visits;
		 if ($mon == "Mar") $mons[2] += $visits;
		 if ($mon == "Apr") $mons[3] += $visits;
		 if ($mon == "May") $mons[4] += $visits;
		 if ($mon == "Jun") $mons[5] += $visits;
		 if ($mon == "Jul") $mons[6] += $visits;
		 if ($mon == "Aug") $mons[7] += $visits;
		 if ($mon == "Sep") $mons[8] += $visits;
		 if ($mon == "Oct") $mons[9] += $visits;
		 if ($mon == "Nov") $mons[10] += $visits;
		 if ($mon == "Dec") $mons[11] += $visits;
		 
		 $year = $yeartmp - $startyear;
		 $years[$year][0] = $yeartmp;
		 $years[$year][1] += $visits;
		
		 $ie += $row[$i]["ie"];
		 $moz += $row[$i]["moz"];
		 $opera += $row[$i]["opera"];
		 $safari += $row[$i]["safari"];
		 $text += $row[$i]["text"];
		 $brow_unknown += $row[$i]["brow_unknown"];
		 $win += $row[$i]["win"];
		 $lin += $row[$i]["lin"];
		 $mac += $row[$i]["mac"];
		 $bsd += $row[$i]["bsd"];
		 $sun += $row[$i]["sun"];
		 $so_unknown += $row[$i]["so_unknown"];
		}
		
		$tot_pages = 0;
		$pages = array();
		$i = 0;
		$query = "SELECT page, visit FROM ".$webstats["table"]["pages"]." ORDER BY visit DESC LIMIT 0, 10";
		$row = _ISI_DBQUERY($query);
		for ($i=0;$i < count($row); $i++) {
		 $pages[$i][0] = $row[$i]["page"];
		 $pages[$i][1] = $row[$i]["visit"];
		 $tot_pages += $row[$i]["visit"];
		}
		
		print('<h1 align="center">'.$webstats_txt["title1"].'</h1>');
		
		print('<div>'.$webstats_txt["body1"].' <b>'.$tot_visit.'</b> '.$webstats_txt["body2"].' 
				<b>'.substr($first_date,8,2).'-'.substr($first_date,5,2).'-'.substr($first_date,0,4).'</b>, 
				<b>'.$tot_today.'</b> '.$webstats_txt["body3"].', <b>'.$yesterday.'</b> '.$webstats_txt["body4"].'.</div>');
		if ($numpages_most_visit_day > 0 && $numpages_less_visit_day > 0)
			print($webstats_txt["body5"].' <b>'.substr($most_visit_day,8,2).'-'.substr($most_visit_day,5,2).'-'.substr($most_visit_day,0,4).'</b>
				(<b>'.$numpages_most_visit_day.'</b> '.$webstats_txt["body6"].' 
				<b>'.substr($less_visit_day,8,2).'-'.substr($less_visit_day,5,2).'-'.substr($less_visit_day,0,4).'</b> 
				(<b>'.$numpages_less_visit_day.'</b> '.$webstats_txt["body7"]);
		
		for ($n = 0; $n < count($days); $n++) {
		 if ($days[$n] > $day_most_visit || $day_most_visit == -1) {
		  $day_most_visit = $days[$n];
		  if ($n == 0) $day_most = $webstats_txt["day1"];
		  if ($n == 1) $day_most = $webstats_txt["day2"];
		  if ($n == 2) $day_most = $webstats_txt["day3"];
		  if ($n == 3) $day_most = $webstats_txt["day4"];
		  if ($n == 4) $day_most = $webstats_txt["day5"];
		  if ($n == 5) $day_most = $webstats_txt["day6"];
		  if ($n == 6) $day_most = $webstats_txt["day7"];
		 }
		 if ($days[$n] != 0 && $days[$n] < $day_less_visit || $day_less_visit == -1) {
		  $day_less_visit = $days[$n];
		  if ($n == 0) $day_less = $webstats_txt["day1"];
		  if ($n == 1) $day_less = $webstats_txt["day2"];
		  if ($n == 2) $day_less = $webstats_txt["day3"];
		  if ($n == 3) $day_less = $webstats_txt["day4"];
		  if ($n == 4) $day_less = $webstats_txt["day5"];
		  if ($n == 5) $day_less = $webstats_txt["day6"];
		  if ($n == 6) $day_less = $webstats_txt["day7"];
		 }
		}
		print('<div>'.$webstats_txt["body8"].' <b>'.$day_most.'</b> '.$webstats_txt["body9"].' <b>'.$day_most_visit.'</b> '.$webstats_txt["body10"].'<b>'.number_format((($day_most_visit * 100) / $tot_visit), 2).'%</b> '.$webstats_txt["body11"].' <b>'.$day_less.'</b> '.$webstats_txt["body12"].' <b>'.$day_less_visit.'</b> '.$webstats_txt["body13"].'<b>'.number_format((($day_less_visit * 100) / $tot_visit), 2).'%</b> '.$webstats_txt["body14"].'.</div><br/>');
		
		print('<table style="margin:auto;margin-bottom:10px;" width="80%" cellpadding="0" border="0" cellspacing="0">
		 <tr>
		 	<td id="menu-topsx-nocolor"></td>
		    <td id="menu-up-nocolor"></td>
		    <td id="menu-topdx-nocolor"></td>
		 </tr>
		 <tr>
		 	<td id="menu-sx"></td><td id="menu-body">');
		 	print('<div align="left"><b>'.$webstats_txt["title2"].'</b></div>');
		print('<table width="100%" cellpadding="0" border="0" cellspacing="0">');
		for ($n = 0; $n < count($days); $n++) {
		 $perc = number_format((($days[$n] * 100) / $tot_visit), 2);
		 $td_perc = $perc / 1.7;
		 if ($n == 0) $day_perc = $webstats_txt["day1"];
		 if ($n == 1) $day_perc = $webstats_txt["day2"];
		 if ($n == 2) $day_perc = $webstats_txt["day3"];
		 if ($n == 3) $day_perc = $webstats_txt["day4"];
		 if ($n == 4) $day_perc = $webstats_txt["day5"];
		 if ($n == 5) $day_perc = $webstats_txt["day6"];
		 if ($n == 6) $day_perc = $webstats_txt["day7"];
		 print('<tr><td align="right" width="30%">'.$day_perc.'</td><td width="30%" align="center">
			<b>'.$days[$n].'</b> '.$webstats_txt["visits"].'</td><td width="40%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.$perc.'%)</small></td></tr>');
		}
		print('</table>');
		print('</td>
			<td id="menu-dx"></td></tr>
		 <tr>
		 	<td id="menu-bottomsx"></td><td id="menu-down"></td><td id="menu-bottomdx"></td>
		 </tr>
		 </table>');
		
		print('<table style="margin:auto;margin-bottom:10px;" width="80%" cellpadding="0" border="0" cellspacing="0">
		 <tr>
		 	<td id="menu-topsx-nocolor"></td>
		    <td id="menu-up-nocolor"></td>
		    <td id="menu-topdx-nocolor"></td>
		 </tr>
		 <tr>
		 	<td id="menu-sx"></td><td id="menu-body">');
		 	print('<div align="left"><b>'.$webstats_txt["title3"].'</b></div>');
		print('<table width="100%" cellpadding="0" border="0" cellspacing="0">');
		for ($n = 0; $n < count($mons); $n++) {
		 if ($mons[$n] != 0) {
		  $perc = number_format((($mons[$n] * 100) / $tot_visit), 2);
		  $td_perc = $perc / 1.7;
		  if ($n == 0) $mon_perc = $webstats_txt["month1"];
		  if ($n == 1) $mon_perc = $webstats_txt["month2"];
		  if ($n == 2) $mon_perc = $webstats_txt["month3"];
		  if ($n == 3) $mon_perc = $webstats_txt["month4"];
		  if ($n == 4) $mon_perc = $webstats_txt["month5"];
		  if ($n == 5) $mon_perc = $webstats_txt["month6"];
		  if ($n == 6) $mon_perc = $webstats_txt["month7"];
		  if ($n == 7) $mon_perc = $webstats_txt["month8"];
		  if ($n == 8) $mon_perc = $webstats_txt["month9"];
		  if ($n == 9) $mon_perc = $webstats_txt["month10"];
		  if ($n == 10) $mon_perc = $webstats_txt["month11"];
		  if ($n == 11) $mon_perc = $webstats_txt["month12"];
		  print('<tr><td align="right" width="30%">'.$mon_perc.'</td><td width="30%" align="center">
			<b>'.$mons[$n].'</b> '.$webstats_txt["visits"].'</td><td width="40%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.$perc.'%)</small></td></tr>');
		 }
		}
		print('</table>');
		print('</td>
			<td id="menu-dx"></td></tr>
		 <tr>
		 	<td id="menu-bottomsx"></td><td id="menu-down"></td><td id="menu-bottomdx"></td>
		 </tr>
		 </table>');
		
		
		print('<table style="margin:auto;margin-bottom:10px;" width="80%" cellpadding="0" border="0" cellspacing="0">
		 <tr>
		 	<td id="menu-topsx-nocolor"></td>
		    <td id="menu-up-nocolor"></td>
		    <td id="menu-topdx-nocolor"></td>
		 </tr>
		 <tr>
		 	<td id="menu-sx"></td><td id="menu-body">');
		 	print('<div align="left"><b>'.$webstats_txt["title4"].'</b></div>');
		print('<table width="100%" cellpadding="0" border="0" cellspacing="0">');
		for ($n = 0; $n < count($years); $n++) {
		  $perc = number_format((($years[$n][1] * 100) / $tot_visit), 2);
		  $td_perc = $perc / 1.7;
		  print('<tr><td align="right" width="30%">'.$webstats_txt["year"].' '.$years[$n][0].'</td>
			<td width="30%" align="center"><b>'.$years[$n][1].'</b> '.$webstats_txt["visits"].'</td>
			<td width="40%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.$perc.'%)</small></td></tr>');
		}
		print('</table>');
		print('</td>
			<td id="menu-dx"></td></tr>
		 <tr>
		 	<td id="menu-bottomsx"></td><td id="menu-down"></td><td id="menu-bottomdx"></td>
		 </tr>
		 </table>');
		
		print('<table style="margin:auto;margin-bottom:10px;" width="80%" cellpadding="0" border="0" cellspacing="0">
		 <tr>
		 	<td id="menu-topsx-nocolor"></td>
		    <td id="menu-up-nocolor"></td>
		    <td id="menu-topdx-nocolor"></td>
		 </tr>
		 <tr>
		 	<td id="menu-sx"></td><td id="menu-body">');
		 	print('<div align="left"><b>'.$webstats_txt["title5"].'</b></div>');
		print('<table width="100%" cellpadding="0" border="0" cellspacing="0">');
		
		$perc = number_format((($ie * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right" width="10%"><img src="'.$webstats["images"].'/explorer.png" /></td>
				<td width="30%">Explorer:</td><td width="20%">'.$ie.' '.$webstats_txt["users"].'</td>
				<td width="40%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($ie * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($moz * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/firefox.png" /></td><td>Mozilla:</td>
				<td>'.$moz.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($moz * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($opera * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/opera.png" /></td><td>Opera:</td>
				<td>'.$opera.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($opera * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($safari * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/safari.png" /></td><td>Safari:</td>
				<td>'.$safari.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($safari * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($text * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/text_brow.png" /></td><td>Text based:</td>
				<td>'.$text.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($text * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($brow_unknown * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/unknown.png" /></td><td>Unknown:</td>
				<td>'.$brow_unknown.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($brow_unknown * 100) / $tot_visit), 2).'%)</small></td></tr>');
		print('</table>');
		print('<br/>');
		print('<div align="left"><b>'.$webstats_txt["title6"].'</b></div>');
		print('<table width="100%" cellpadding="0" border="0" cellspacing="0">');
		
		$perc = number_format((($win * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right" width="10%"><img src="'.$webstats["images"].'/windows.png" /></td>
				<td width="30%">Windows:</td><td width="20%">'.$win.' '.$webstats_txt["users"].'</td><td width="40%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($win * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($lin * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/linux.png" /></td><td>Linux:</td>
				<td>'.$lin.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($lin * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($mac * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/mac.png" /></td><td>Mac OS:</td>
				<td>'.$mac.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($mac * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($bsd * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/bsd.png" /></td><td>Bsd OS:</td>
				<td>'.$bsd.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($bsd * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($sun * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/sun.png" /></td><td>Sun OS:</td>
				<td>'.$sun.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($sun * 100) / $tot_visit), 2).'%)</small></td></tr>');
		
		$perc = number_format((($so_unknown * 100) / $tot_visit), 2); $td_perc = $perc / 1.7;
		print('<tr><td align="right"><img src="'.$webstats["images"].'/unknown.png" /></td><td>Unknown:</td>
				<td>'.$so_unknown.' '.$webstats_txt["users"].'</td><td width="50%"><img src="'.$webstats["images"].'/bar.png"
			width="'.number_format($td_perc).'%" height="15" border="0" alt="" /><img src="'.$webstats["images"].'/chartround.png"
			width="9" height="15" border="0" alt="" /> <small style="vertical-align:super">('.number_format((($so_unknown * 100) / $tot_visit), 2).'%)</small></td></tr>');
		print('</table>');
		print('</td>
			<td id="menu-dx"></td></tr>
		 <tr>
		 	<td id="menu-bottomsx"></td><td id="menu-down"></td><td id="menu-bottomdx"></td>
		 </tr>
		 </table>');
		
		$urls = array();
		$i = 0;
		$query = "SELECT url, visit FROM ".$webstats["table"]["urls"]." ORDER BY visit DESC";
		$row = _ISI_DBQUERY($query);
		for ($i=0;$i < count($row); $i++) {
		 $urls[$i][0] = $row[$i]["url"];
		 $urls[$i][1] = $row[$i]["visit"];
		}
		print('<br/>');
		print('<div align="center"><b>'.$webstats_txt["urltitle"].'</b></div>');
		print('<table width="100%" cellspacing="5">');
		for ($n = 0; $n < count($urls); $n++) {
		 print('<tr><td width="45%" align="right">'.$urls[$n][1].' '.$webstats_txt["users"].':</td>
			<td width="55%">'.$urls[$n][0].'</a></td></tr>');
		}
		print('</table>');
		
		
		
		print('<br/>');
		print('<div align="center"><b>'.$webstats_txt["title7"].'</b></div>');
		print('<table width="100%" cellspacing="5">');
		for ($n = 0; $n < count($pages); $n++) {
			$pages[$n][0] = $pages[$n][0] != "index" ? $pages[$n][0]: "Home";
		 print('<tr><td width="50%" align="right">'.$pages[$n][1].' '.$webstats_txt["visits"].':</td>
			<td width="50%">'.$pages[$n][0].'</td></tr>');
		}
		print('</table>');
		print('<br/>');
		
		
		print('<div align="center">'.$webstats_txt["title8"].': <b>'.$tot_pages.'</b>.<br/>');
		print(''.$webstats_txt["title9"].': <b>'.number_format(($tot_pages / $tot_visit), 2).'</b>.</div>');
	}
}

?>
