<?php

# include global configurations and connects to database
include ('conf.php');

_ISI_DBCONN();

/* load all drivers needed to boot */
# select default language
$tmplocale = ((isset($modlocale) && $modlocale != null) && ($modlocale != ''))? $modlocale : $locale;
$finalocale = (($locale != null) && ($locale != ''))? $locale : $tmplocale;

# load locale
@include_once('drivers/locale/'.$finalocale.'.php');
# load driver
for ($i=0;$i<count($inetd["drivers"]);$i++) require_once('drivers/'.$inetd["drivers"][$i].'.php');

# load inetd main library for login, logout, session management and admin management
include_once ('lib.php');

# reload drivers locale as defined in user's cookie
$userlocale = _ISI_LOCALE();
@include_once('drivers/locale/'.$userlocale.'.php');
	
// DATABASE MANAGER
# debug management
#
# void (print any passed variable, if is to debug)
function _ISI_DEBUG($strin, $whatis = null) {
 global $inetd;
 if ($inetd["debug"] && $inetd["action"] != "header") {
 	if ($whatis != null) print_r("".$whatis.": ");
 	print_r("\"".$strin."\"");
 	print("<br />");
 }
}

# load configurations from database
#
# void
function _ISI_POSTCONF() {
	global $inetd, $layout;
	include ('postconf.php');
	include($inetd["templatepath"].'/'.$layout.'/'.$inetd["templateconf"].'.php');
}

# database connection wrapper
#
# db connection obj (globally exports db connection object)
function _ISI_DBCONN() {
 global $inetd, $db_conn, $maintenaince,$pdo_interface;
 $db_conn_errors = false;
 
 switch ($inetd["dbtype"]) {
 	case "mysql":
 		if ($inetd["dbport"] != null && isset($inetd["dbhost"])) {
 			$mysqli_port = $inetd["dbport"];
 			$inetd["dbport"] = ":".$inetd["dbport"];
 		} else $mysqli_port = "3306";
 		
 		$db_conn = mysqli_connect($inetd["dbhost"],$inetd["dbuser"],$inetd["dbpass"],$inetd["maindb"],$mysqli_port);
 		if (mysqli_connect_errno()) $db_conn_errors = true;

		$dsn = 'mysql:dbname='.$inetd["maindb"].';host='.$inetd["dbhost"].$inetd["dbport"];
		$dsnPdo = 'mysql:dbname='.$inetd["maindb"].';host='.$inetd["dbhost"].';charset=utf8';
		try {
			$pdo_interface = new PDO($dsnPdo, $inetd["dbuser"], $inetd["dbpass"],array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8"));
			$pdo_interface->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			$pdo_interface->exec('SET NAMES utf8'); // METHOD #3
			$pdo_interface->exec('SET CHARACTER SET utf8'); // METHOD #4
		}
		catch (RuntimeException $e){
			echo 'ERRORE DURANTE LA CREAZIONE DELL\'OGGETTO PDO DI CONNESSIONE. CONTATTARE I SISTEMISTI';
		}	
 		if (isset($db_conn) && $db_conn != null && $db_conn_errors == false) {
 			#mysql_select_db($inetd["maindb"], $db_conn) or die("db selection error: " . mysqli_error());
 			mysqli_select_db($db_conn, $inetd["maindb"]) or die("db selection error: " . mysqli_error());
 			if ($inetd["encode"] == "utf8") mysqli_query($db_conn, "SET NAMES 'utf8'");
 		}
 		else $maintenaince = true;
 		break;
 }
 return $db_conn;
}

# database disconnection wrapper
#
# void
function _ISI_DBDISCONN() {
 global $inetd, $db_conn;
 switch ($inetd["dbtype"]) {
 	case "mysql":
 		$db_conn = @mysqli_close($db_conn);
 		break;
 }
 return $db_conn;
}

function _ISI_INSERTDB() {
	global $db_conn;
	return mysqli_insert_id($db_conn);
}

# wrapper to mysql_escape
#
# return a string
function _ISI_MYESCAPE($in_str) {
	global $db_conn;
	return mysqli_escape_string ($db_conn, $in_str);
}


# main function used to perform a db query (safe, pdo)
#
# return an array (void if query is void)
function _ISI_DBQUERY_PDO($query = null,$parameters = null,$transaction = false) {
	global $inetd,$pdo_interface;
	
	if ($query == null || strlen ($query) == 0){
		return;
	}
	
/*
 	if ($parameters == null){
 		$reply = $pdo_interface->query($query);
 		$returnArray = $reply->fetchAll();
//	 		foreach ($reply as $row) {
//	 			$returnArray[] = $row;
//	 		}
 		echo '<pre>';
 		echo 'CAPPERI:';
 		print_r ($returnArray);
 		echo '</pre>';
 		return $returnArray;
 	}
*/
	
	
	if ($parameters!=null && sizeOf($parameters) > 0) {
		foreach ($parameters as $key=>$param){
			if (is_string($param)){
				$parameters[$key] = utf8_decode($param);
			}
		}
	}
	
	$stmt = $pdo_interface->prepare($query);
	try {
		if ($stmt->execute($parameters)){
			if (preg_match('/^INSERT/',$query)){
				$id = $pdo_interface->lastInsertId();
				return $id;
			}
			if (preg_match('/^SELECT/',$query)){
				$returnArray = array();
				foreach ($stmt as $row) {
					$returnArray[] = $row;
				}
				return $returnArray;
			}
		}
		else {
			if ($inetd["printdbstacktrace"]) {
	 				$errarray = debug_backtrace();
	 				print ("<pre>");
	 				print ("<h3>ERROR STACK TRACE</h3>");
	 				print ("<b>query: ".$query." (CODE: ". $stmt->errorCode() .")</b><br />");
	 				print_r($stmt->errorInfo());
	 				print ("</pre>");
	 				
	 				for ($i = 0; $i < count($errarray); $i++) {
	 					print('<b>file:</b> '.$errarray[$i]["file"].'<br />');
	 					print('<b>function:</b> '.$errarray[$i]["function"].'<br />');
	 					print('<b>line:</b> '.$errarray[$i]["line"].'<br />');
	 				}
	 		}
		}
	}
	catch(PDOException $e){
		//memorizzo l'errore nella tabella apposita
		$applicationError = new applicationError();
		$applicationError->setErrorDate(time());
		$applicationError->setQuery($query);
		$applicationError->setParameters($parameters);
		$applicationError->setErrorText($e->getMessage());
		$applicationError->setErrorFile($e->getFile());
		$applicationError->setErrorLine($e->getLine());
		$applicationError->setErrorStackTrace($e->getTraceAsString());
		$id = $applicationError->insertDB();
		
		if ($inetd["printdbstacktrace"]) {
 			$errarray = debug_backtrace();
 			print ("<pre>");
 			print ("<h3>ERROR STACK TRACE</h3>");
 			print ("<b>query: ".$query." (CODE: ". $stmt->errorCode() .")</b><br />");
 			print_r($stmt->errorInfo());
 			print ("</pre>");
 			
 			for ($i = 0; $i < count($errarray); $i++) {
 				print('<b>file:</b> '.$errarray[$i]["file"].'<br />');
 				print('<b>function:</b> '.$errarray[$i]["function"].'<br />');
 				print('<b>line:</b> '.$errarray[$i]["line"].'<br />');
 			}
 		}
	
		if ($inetd["sendemailstacktrace"]) { 
			_ISI_SENDMAIL ($inetd['debug_email'],"APPLICATION_ERROR",$applicationError->toText());
		}
		
		print '<span style="color:#990000">Errore generico durante l\'esecuzione dell\'operazione. Il codice di errore &egrave;: <b>ERR1400'.$id.'</b>. Contattare gli sviluppatori e fornire questo codice.</span>';
		throw new RuntimeException("Errore generico durante l'esecuzione dell'operazione. Il codice di errore è: <b>ERR1400$".$id."</b>. Contattare gli sviluppatori e fornire questo codice.");
	}
	catch(RuntimeException $e){
		//memorizzo l'errore nella tabella apposita
		$applicationError = new applicationError();
		$applicationError->setErrorDate(time());
		$applicationError->setQuery($query);
		$applicationError->setParameters($parameters);
		$applicationError->setErrorText($e->getMessage());
		$applicationError->setErrorFile($e->getFile());
		$applicationError->setErrorLine($e->getLine());
		$applicationError->setErrorStackTrace($e->getTraceAsString());
		$id = $applicationError->insertDB();

		if ($inetd["printdbstacktrace"]) {
			$errarray = debug_backtrace();
			print ("<pre>");
			print ("<h3>ERROR STACK TRACE</h3>");
			print ("<b>query: ".$query." (CODE: ". $stmt->errorCode() .")</b><br />");
			print_r($stmt->errorInfo());
			print ("</pre>");
		
			for ($i = 0; $i < count($errarray); $i++) {
				print('<b>file:</b> '.$errarray[$i]["file"].'<br />');
				print('<b>function:</b> '.$errarray[$i]["function"].'<br />');
				print('<b>line:</b> '.$errarray[$i]["line"].'<br />');
			}
		}
		
		if ($inetd["sendemailstacktrace"]) {
			_ISI_SENDMAIL ($inetd['debug_email'],"APPLICATION_ERROR",$applicationError->toText());
		}
		
		print '<span style="color:#990000">Errore generico durante l\'esecuzione dell\'operazione. Il codice di errore &egrave;: <b>ERR1400'.$id.'</b>. Contattare gli sviluppatori e fornire questo codice.</span>';
		throw new RuntimeException("Errore generico durante l'esecuzione dell'operazione. Il codice di errore è: <b>ERR1400$".$id."</b>. Contattare gli sviluppatori e fornire questo codice.");
	}
}

# wrapper function used to perform a db query
#
# return an array (void if query is void)
function _ISI_DBQUERY($in_query, $islog = false) {	
 global $inetd, $db_conn;
 if ($inetd["logging"]["enable"]) {
 	if (!$islog) _ISI_LOGGING($in_query);
 }
 return _ISI_DBQUERY_PDO ($in_query,null,false); 
}


# log a query
#
# void
function _ISI_LOGGING($in_query) {
	global $db_conn, $id_user, $inetd;

	$dbquery = ""; $todo = true;
	$loggingarray = explode(" ", $inetd["logging"]["excluded_tables"]);
	for ($i = 0; $i < count($loggingarray); $i++) {
		if (preg_match("/".$loggingarray[$i]."/i", $in_query)) {
			//$debug .= "query: ".$in_query."<br />\n";
			//$debug .= "match: ".$array[$i]."<br />\n";
			$todo = false;
			break;
		}
		if (preg_match("/SELECT/i", $in_query)) {
			//$debug .= "query: ".$in_query."<br />\n";
			//$debug .= "match: SELECT<br />\n";
			$todo = false;
			break;
		}
	}
	if ($todo) {
		if ($id_user == "Guest") $id_tmp_member = 0;
		else $id_tmp_member = $id_user;
		$ip = $_SERVER["REMOTE_ADDR"];
		$url = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		$now = time();

		$dbquery = _ISI_MYESCAPE($in_query);
		$table = $inetd["userlog_table"];
		//$debug .= "dbquery: ".$dbquery."<br />\n";
		$tmpquery = "SELECT count( * ) FROM ".$table."
					WHERE ID_MEMBER = '".$id_member."' AND date = '".$now."'
					AND ip = '".$ip."' AND url = '".$url."' AND query = '".$dbquery."';";
		$reply = _ISI_DBQUERY($tmpquery);
		if ($reply[0][0] == 0) {
			$querymax = "SELECT MAX( ID_LOG ) FROM ".$table.";";
			$replymax = _ISI_DBQUERY($querymax);
			if ($replymax[0][0] != null) $max = $replymax[0][0] + 1;
			else $max = 1;
			$tmpquery = "INSERT INTO ".$table."
					(".$table.".ID_LOG, ".$table.".ID_MEMBER, ".$table.".date, ".$table.".ip, ".$table.".query, ".$table.".url)
					VALUES ('".$max."', '".$id_tmp_member."', '".$now."', '".$ip."', '".$dbquery."', '".$url."');";
			//ON DUPLICATE KEY UPDATE date = date";
			# Questo "true" serve per dire a _ISI_DBQUERY di non chiamare _ISI_LOGGING
			# per loggare, altrimenti ci inloopiamo
			_ISI_DBQUERY($tmpquery, true);
		}
	}
}

# old query function, dropped
function _NOT_SAFE_ISI_DBQUERY($in_query){
	global $inetd, $db_conn;
	
	/*switch ($inetd["dbtype"]) {
		case "mysql":
			if (isset($in_query) && isset($db_conn)) {
				//_ISI_DEBUG($in_query,"query");
				//'and(select 1 from (select count(*), concat(@@version,floor(rand(0)*2))x from information_schema.tables group by x)a)and'//
				$request = mysqli_query($db_conn, $in_query);
				if (preg_match('/^INSERT/',$in_query)){
					return mysqli_insert_id($db_conn);
				}
				if (is_resource($request) && isset($request) && $request != '1') {
					$i = 0;
					while ($row = mysqli_fetch_array($request)) {
						$keys = array_keys($row); $k = 0;
						for ($n = 0; $n < count($row); $n++) {
							$retarray[$i][$keys[$k++]] = $row[$n];
							$retarray[$i][$keys[$k++]] = $row[$n];
						}
						$i++;
					}
				}
				if ($request == '0') {
					if ($inetd["printdbstacktrace"]) {
						$errarray = debug_backtrace();
						print ("<h3>ERROR STACK TRACE</h3>");
						print ("<b>query: ".$in_query." (". mysqli_error() .")</b><br />");
						for ($i = 0; $i < count($errarray); $i++) {
							print('<b>file:</b> '.$errarray[$i]["file"].'<br />');
							print('<b>function:</b> '.$errarray[$i]["function"].'<br />');
							print('<b>line:</b> '.$errarray[$i]["line"].'<br />');
						}
					}
				}
			}
	}*/
}


// DATABASE MANAGER // END
//*************************
# LOADER FUNCTION
# include al volo la lib.php (se serve) e l'include del modulo richiesto.
# l'index a sua volta include la pagina necessaria con lo stile da usare;
# le impostazioni vengono passate le 4 variabili globali $mod
#
# void
function inetd($inmodname, $inmodpage, $inmodtemplate = null, $inside = null) {
	global $inetd, $mods, $modname, $modpage, $modtemplate, $side;
	if (is_file($inetd["modpath"].'/inetd/loader.php')) {
		$modname = $inmodname;
		$modpage = $inmodpage;
		$modtemplate = $inmodtemplate;
		if ($inside == "admin") $side = 2;
		elseif ($inside == "noadmin") $side = 1;
		elseif ($inside == "public") $side = 0;
		else $side = -1;
		require($inetd["modpath"].'/inetd/loader.php');
	}
	else exit("missing loader");
}

?>
