<?php

### maintenaince mode / memory allocation
$maintenaince = false;
$maintenaincefile = "include/common/maintenaince.html";
//ini_set("memory_limit","-1"); //settato da sistema
//ini_set("display_errors","Off"); //da attivare per evitare print di errori (gia' presente a sistema)
//ini_set("upload_max_filesize", "15M"); //da mettere nel sistema
//ini_set("post_max_size", "15M"); //da mettere nel sistema
//ini_set('max_execution_time', 300); //da mettere nel sistema
//ini_set('DELETE mysql.STRICT_TRANS_TABLES') //da fare su mysql

### global variables used by whole system, usually not to overwrite
$db_conn = null; //var used as connection to database
$pdo_interface = null;// DB Object to prevent sql-injection
$modrequest = null; //module name requested
$id_user = "Guest"; //var used to let know user id (Guest if is not authed)
$maingroups = null; //array used to store all available maingroups (name - build in lib.php)
$groups = null; //array used to store all available groups (name,descr - build in lib.php)
$isadmin = false; //boolean used to know if a user is generic admin
$adminlogged = false; //boolean used to know if admin is logged in
$authtype = "session"; # auth "cookie" or "session" (default) based, warn about cookie: issues with proxy 
$layout = "default"; //default global layout (used as the once in admin side)
$template = "public"; //default global template (used as the once in admin side)
$locale = "en_GB"; //global var used as default locale (used as the once in admin side)
//$inetd["locale"][0] = "it_IT";   these vars are defined PER template
//$inetd["locale"][1] = "en_GB";   as they can be used only in some sites
$force_https = false; // if true force url to be https

### engine array
# username - $userinfo["username"] (Guest if not authed) 
# fake - $userinfo["userfake"] (Realname) 
# usergroup - $userinfo["usergroup"] (Name used to know main user group, null if is not authed)
# groups - $userinfo["groups"] (Array used to know which groups a user is part of, [$id_user][$groupname])
# firstLogin - $userinfo["firstLogin"] (integer, 1 == password must be changed)
# usermail - $userinfo["usermail"] (email)
$userinfo = array(); //array where store informations about a logged user
$mods = array(); // array used to store loaded modules name
$html = array(); //array in which html code is stored (used inside modules, lastly printed by loader.php)

### boot configurations
$inetd["dbtype"] = "mysql"; //can be mysql, ...
$inetd["encode"] = "utf8"; //db encode, utf8 - latin1 etc..
$inetd["dbhost"] = "localhost"; //db host
$inetd["dbport"] = "3306"; //db port - if not set: mysql uses 3306
$inetd["dbprefix"] = "isicms_"; //db prefix
#$inetd["debug_email"] = "debug@localhost"; //in remoteconf
#$inetd["dbuser"] = "isicms"; //in remoteconf
#$inetd["dbpass"] = "isicms"; //in remoteconf
#$inetd["maindb"] = "isicms"; //in remoteconf
#$inetd["printdbstacktrace"] = true; //in remoteconf
#$inetd["sendemailstacktrace"] = false; //in remoteconf

### login vars and session vars
$inetd["loginenabled"] = false; //by default is disabled, enabled only for vhost
$inetd["logingroups"] = null; //null -> all groups, false -> no groups, "group1 group2" -> only listed
$inetd["authcookie"] = "ISIcookie";
$inetd["authsession"] = "ISIauth";
$inetd["cookietime"] = null; //default cookie time, null for end of seession, 10 years -> time() + (60 * 60 * 24 * 365);
$inetd["license"] = false; //true means that a license must be accepted
$inetd["userlog_table"] = $inetd["dbprefix"]."log_users"; // table to log users queries

### paths, debug and logging
$inetd["debug"] = true; //enable/disable debug
$inetd["action"] = "header"; //tell core we are performing header (used by debug function)
$inetd["user_agent"] = $_SERVER['HTTP_USER_AGENT']; //get user informations (broser, s.o. etc)
$inetd["dns"] = $_SERVER["HTTP_HOST"]; //get server host (maybe change it to a fixed one)
$inetd["basepath"] = "/"; //default site path (overwritten by lib.php)
$inetd["url"] = "http://"; //default protocol to use ($inetd["url"] will be completely build in lib.php)
$inetd["furtherurl"] = ""; //post $modrequest called url, completely build in lib.php
$inetd["print_modname"] = 0; //print which module is printing html (useful for debug)
$inetd["logging"]["enable"] = true; //tells boot.php to log all queries
// if logging is enable, does not log query to these tables (prefix will be automatically prepend)
$inetd["logging"]["excluded_tables"] = "isicms_log_activity isicms_log_online webstats_log webstats_online webstats_pages webstats_urls webstats_visits";

### global paths and configurations
$inetd["admingroup"] = "Administrator"; //admin group
$inetd["includepath"] = "include";
$inetd["modpath"] = "modules";
$inetd["imgpath"] = "images"; //will be completely build in lib.php (with layout)
$inetd["imgorigpath"] = $inetd["imgpath"]; //used only as original img path (used when changing layout)
$inetd["imgcommonpath"] = $inetd["imgpath"]."/common";
$inetd["templatepath"] = "template";
$inetd["templateconf"] = "conf";
$inetd["webstatscount"] = true;

### signup options
$inetd["trackStats"] = true; //keep statistics about new users
$inetd["deletedrop"] = false; //if true delete user row, else disable it by setting void password
$inetd["timeoffset"] = 0; //Time Offset (so if your server is EST, this would be set to -1 for CST)
$inetd["emailpassword"] = true; //currently true is the only way
$inetd["useveriword"] = false; //currently false is the only way
$inetd["mailtype"] = 1; //0 - sendmail, 1 - SMTP
$inetd["smtp_server"] = "127.0.0.1"; //SMTP-Server
$inetd["smtp_username"] = null; //SMTP-Server username, null if not to use
$inetd["smtp_password"] = null; //SMTP-Server password, null if not to use
$inetd["webmaster_mail"] = "noreply@localhost";
$inetd["webmaster_mail_nospam"] = "noreply _AT_ localhost";

#drivers to load
$inetd["drivers"][0] = "isicms"; //main driver

# global cms meta options
$inetd["GETpage"] = "page"; //page get
$inetd["GETauth"] = "auth"; //login/logout get
$inetd["GETlocale"] = "locale"; //locale get
$inetd["GETlayout"] = "layout"; //layout get
$inetd["GETtemplate"] = "template"; //template get
$inetd["NotFound"] = "NotFound"; //page not found

### session check type: if an used id is part of this list (separated by comma)
### _ISI_SESSION will print a "user already logged in" page
$inetd["sessiongroups"] = "1,";
# password management
$inetd["passwordendlife"] = "7776000"; # in seconds
### download management (lib.php -> _ISI_CHECKREPOPERMS())
# db table
$inetd["download_table"] = $inetd["dbprefix"]."download_permissions";
# main GET
$inetd["download"] = "download";
 
# common template definitions
$inetd["commontemplatepath"] = "common";
# common stylesheet used to change style using javascript
$inetd["commonstylesheet"][0] = "font_normal"; //this name is used in script -> 241:getPreferredStyleSheet()
$inetd["commonstylesheet"][1] = "font_big";
$inetd["commonstylesheet"][2] = "font_small";
$inetd["commonstylesheet"][3] = "calendar";
$inetd["commonstylesheet"][4] = "jquery-ui";
# common <head>scripts</head>
$inetd["commonheadscripts"][0] = "isicommonscripts";
$inetd["commonheadscripts"][1] = "jsxmidlink";
$inetd["commonheadscripts"][2] = "calendar";
$inetd["commonheadscripts"][3] = "nicEdit";
$inetd["commonheadscripts"][4] = "jquery";
$inetd["commonheadscripts"][5] = "jquery-ui";
# common scripts.js functions caller - if needed to load after html
$inetd["commonfootscripts"][0] = "tt_Init();"; //used to load isitooltip
# external path
$inetd["externalpath"] = "";

# vhost configuration
include("vhost.php");

# remote configuration
include("remoteconf.php");
?>
