<?php
/**
 * console runtime functions
*
* @package inetd.console
* @author rio
* @version 0.0.4
* @copyright Copyright (C) Sergio Rizzi
*/
class ISIconsole {
	/**
	 * @var int class version
	 */
	public $version = '0.0.4';

	/**
	 * construcor: void
	 *
	 * @param $parms string function to perform
	 */
	function ISIconsole($parms) {
		array_shift($parms);
		switch ($parms[0]) {
			case 'config':
				array_shift($parms);
				return $this->configs($parms);
				break;

			case 'checkpwds':
				return $this->checkPasswords();
				break;

			case 'flushpwds':
				return $this->flushOldPassword();
				break;

			case 'flusholdpermsrepo':
				return $this->flushRepositoryOldPermissions();
				break;

			default:
				return null;
				break;
		}
	}

	/***** FUNCTIONS *****/

	/**
	 * return cms configurations
	 *
	 * @param array $request type of configuration requested
	 */
	public function configs($request) {
		global $inetd;
		$return = null;
		$parm1 = $request[1];
		switch ($request[0]) {
			case 'maindb':
				$return = $inetd["maindb"];
				break;
			case 'dbuser':
				$return = $inetd["dbuser"];
				break;
			case 'dbpass':
				$return = $inetd["dbpass"];
				break;
			case 'dbhost':
				$return = $inetd["dbhost"];
				break;
			case 'dbport':
				$return = $inetd["dbport"];
				break;
			case 'prefix':
				$return = $inetd["dbprefix"];
				break;
		}

		echo $return;
	}

	/**
	 * check for out-of-time passwords
	 */
	public function checkPasswords() {
		global $inetd;
		$now = time();
		$alreadydone = array();
		$query = "SELECT ID_MEMBER, pwdChange FROM ".$inetd["dbprefix"]."members_passwd
          ORDER BY pwdChange DESC";
		$reply = _ISI_DBQUERY($query);
		for ($i = 0; $i < count($reply); $i++) {
			$id_member = $reply[$i]["ID_MEMBER"];
			if (!in_array($id_member,$alreadydone)) {
				$alreadydone[] = $id_member;
				if ($id_member != 1) {
					$lastchange = $reply[$i]["pwdChange"];
					$elapsedtime = $now - $lastchange;
					if ($elapsedtime >= $inetd["passwordendlife"]) {
						$query = "UPDATE ".$inetd["dbprefix"]."members
              SET firstLogin = '1' WHERE ID_MEMBER = '".$id_member."'";
						_ISI_DBQUERY($query);
					}
				}
			}
		}
	}

	/**
	 * flush database stored passwords (older than 4 changes)
	 */
	public function flushOldPassword() {
		global $inetd;
		$now = time();
		$query = "SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members_passwd GROUP BY ID_MEMBER";
		$members = _ISI_DBQUERY($query);
		for ($i = 0; $i < count($members); $i++) {
			$query = "SELECT * FROM ".$inetd["dbprefix"]."members_passwd
            WHERE ID_MEMBER = '".$members[$i]["ID_MEMBER"]."'
            ORDER BY pwdChange DESC LIMIT 4 , 400";
			$reply = _ISI_DBQUERY($query);
			for ($n = 0; $n < count($reply); $n++) {
				$query = "DELETE FROM ".$inetd["dbprefix"]."members_passwd
          WHERE ID_MEMBER = '".$reply[$n]["ID_MEMBER"]."'
          AND passwd = '".$reply[$n]["passwd"]."'
          AND pwdChange = '".$reply[$n]["pwdChange"]."'";
				_ISI_DBQUERY($query);
			}
		}
	}

	/**
	 * flush old stored permissions on file repository
	 */
	public function flushRepositoryOldPermissions() {
		global $inetd;
		$now = time();
		$query = "DELETE FROM ".$inetd["download_table"]." WHERE timeline IS NOT NULL AND timeline < ".$now;
		_ISI_DBQUERY($query);
	}

}