<?php

/*
 * input param must be an array
 *
 * if a function returns smth it should be:
 * $array[0] = false | there's some errors in execution
 * $array[1] = $value | errors in execution
 *
 * $array[0] = true | execution goes ok
 * $array[1] = $value | return value
 */

class isicms {

	/**
	 * constructor
	 */
	function isicms () {
		$version = "1.0.0";
	}

	/**
	 * md5 check function
	 *
	 * return password's md5
	 */
	function _ISI_MD5_HMAC($in_data) {
		$data = $in_data[0];
		$key = $in_data[1];
		if (strlen($key) > 64)
		$key = pack('H*', md5($key));
		$key  = str_pad($key, 64, chr(0x00));
		$k_ipad = $key ^ str_repeat(chr(0x36), 64);
		$k_opad = $key ^ str_repeat(chr(0x5c), 64);
		return md5($k_opad . pack('H*', md5($k_ipad . $data)));
	}

	/**
	 * log management (to perform every time)
	 *
	 * void
	 */
	function _ISI_WRITELOG($in_data) {
		global $inetd, $_SERVER;
		$inid_user = $in_data[0];
		$_SERVER["REMOTE_ADDR"] = $_SERVER["REMOTE_ADDR"];
		if (!is_numeric($inid_user)) $IDTMP_MEMBER = -1;
		else $IDTMP_MEMBER = $inid_user;
	 	/*echo $_SERVER["REMOTE_ADDR"];
	 	echo $IDTMP_MEMBER;*/
		$inetd["header"] = true;
	 	$logTime = time();
	 	if ($IDTMP_MEMBER == -1 && !empty($_SERVER["REMOTE_ADDR"]) && ip2long($_SERVER["REMOTE_ADDR"]) != -1) {
	 		$packedIp = inet_pton($_SERVER["REMOTE_ADDR"]);
	 		if ($packedIp === false) {
	 			$ip = "0.0.0.0";
	 		} else if (isset($packedIp[4])) {
	 			$ip = "0.0.0.0";
	 		} else {
	 			$ip = $_SERVER["REMOTE_ADDR"];
	 		}
	  		_ISI_DBQUERY ("DELETE FROM ".$inetd["dbprefix"]."log_online WHERE logTime < ".($logTime - 900)." OR identity=IFNULL(INET_ATON('".$ip."'), -1)");
	  		_ISI_DBQUERY ("REPLACE INTO ".$inetd["dbprefix"]."log_online (identity, logTime) VALUES (IFNULL(INET_ATON('".$ip."'), -1), ".$logTime.")");
	 	}
	 	else {
	  		if (!is_numeric($IDTMP_MEMBER)) $IDTMP_MEMBER = -1;
	  		_ISI_DBQUERY ("DELETE FROM ".$inetd["dbprefix"]."log_online
					WHERE logTime < ".($logTime - 900)." OR identity=".$IDTMP_MEMBER);
	  		_ISI_DBQUERY ("REPLACE INTO ".$inetd["dbprefix"]."log_online (identity, logTime)
					VALUES (".$IDTMP_MEMBER.", ".$logTime.")");
	 	}
	 	$inetd["header"] = false;
	}

	/**
	 * check if input user and password are valid in database
	 *
	 * input param array($user, $pass)
	 *
	 * return a boolean
	 */
	function _ISI_VALIDATEUSER($in_data) {
		global $inetd;
		$in_user = $in_data[0];
		$in_pass = $in_data[1];
		$reply = _ISI_DBQUERY("SELECT passwd FROM ".$inetd["dbprefix"]."members WHERE memberName='".$in_user."'");
		if ($this->_ISI_MD5_HMAC(array($in_pass, strtolower($in_user))) == $reply[0][0]) {
			return array(true, true);
		}
		else return array(true, false);
	}

	/**
	 * check if input user is disabled
	 *
	 * input param array($user)
	 *
	 * return a boolean
	 */
	function _ISI_ISDISABLEDUSER($in_data) {
		global $inetd;
		$in_user = $in_data[0];
		$reply = _ISI_DBQUERY("SELECT passwd FROM ".$inetd["dbprefix"]."members WHERE memberName='".$in_user."'");
		if ($reply[0][0] == "") {
			return array(true, true);
		}
		else return array(true, false);
	}

	/**
	 * get db's user id
	 *
	 * return an integer
	 */
	function _ISI_IDUSER_FROMDB($in_user) {
		global $inetd;
		$reply = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members WHERE memberName='".$in_user[0]."'");
		return array(true, $reply[0]["ID_MEMBER"]);
	}

	/**
	 * reads auth cookie, if a user is already authed store global id else store "Guest"
	 *
	 * return array with user id or "Guest" if is a visitor
	 */
	function _ISI_IDUSER_FROMCOOKIE() {
		global $inetd, $id_user, $_COOKIE;
		if (function_exists('session_start')) {
			if (isset($_COOKIE))
				$authvar = $_COOKIE;
			else
				$authvar = $_COOKIE;

			if (isset($authvar[$inetd["authcookie"]]) && isset($authvar['PHPSESSID'])) {
				list($username, $password) = @unserialize(stripslashes($authvar[$inetd["authcookie"]]));
				$username = ($username != '') ? $username : 'Guest';
			}
			else {
				$password = '';
			 	$username = 'Guest';
			}
		}
		$id_user = $username;
		return array(true, $id_user);
	}
	
	/**
	 * reads auth session, if a user is already authed store global id else store "Guest"
	 *
	 * return array with user id or "Guest" if is a visitor 
	 */
	function _ISI_IDUSER_FROMSESSION() {
		global $inetd, $id_user, $_SESSION;
		if (function_exists('session_start')) {
			//print_r($_SESSION);
			if (isset($_SESSION[$inetd["authsession"]])) {
				list($username, $password) = @unserialize(stripslashes($_SESSION[$inetd["authsession"]]));
				$username = ($username != '') ? $username : 'Guest';
			}
			else {
				$password = '';
			 	$username = 'Guest';
			}
		}
		$id_user = $username;
		return array(true, $id_user);
	}
	
	/**
	 * set user session id to database
	 */
	function _ISI_SETSESSION($in_data) {
		global $inetd;
		$username = $in_data[0];
		$session = $in_data[1];
		_ISI_DBQUERY ("UPDATE ".$inetd["dbprefix"]."members SET PHPSESSID='".$session."' WHERE memberName = '".$username."'" );
	}

	/**
	 * set user session id to database
	 */
	function _ISI_GETSESSION($in_data) {
		global $inetd;
		$id = $in_data[0];
		$result = _ISI_DBQUERY ("SELECT PHPSESSID FROM ".$inetd["dbprefix"]."members WHERE ID_MEMBER = '".$id."'");
		return array(true, $result[0][0]);
	}

	/**
	 * set user session id to database
	 */
	function _ISI_CLEARSESSION($in_data) {
		global $inetd;
		$id = $in_data[0];
		_ISI_DBQUERY ("UPDATE ".$inetd["dbprefix"]."members SET PHPSESSID=NULL WHERE ID_MEMBER = '".$id."'");
	}

	/**
	 * set a valid cookie to authorize a user and log him on database
	 *
	 * input param array($user, $pass)
	 *
	 * void
	 */
	function _ISI_SETAUTHDATA($in_data) {
		global $inetd, $_SESSION;
		$in_user = $in_data[0];
		$in_pass = $in_data[1];
		$tmp = $this->_ISI_IDUSER_FROMDB(array($in_user));
		$id = $tmp[1];
		$md5_passwrd = $this->_ISI_MD5_HMAC(array($in_pass, strtolower($in_user)));
		$password = $this->_ISI_MD5_HMAC(array($md5_passwrd, 'ys'));
		$authdata = serialize(array($id, $password));
		$_SESSION[$inetd["authsession"]] = $authdata;
		//$ctime = time() + (60 * 60 * 14);
		//setCookie($inetd["authcookie"], $authdata, $ctime, '/');
		setCookie($inetd["authcookie"], $authdata, null, '/');
		$lastLog = time();
		$remote_ip = $_SERVER['REMOTE_ADDR'];
		_ISI_DBQUERY ("UPDATE ".$inetd["dbprefix"]."members SET lastLogin='".$lastLog."',memberIP='".$remote_ip."' WHERE memberName='".$in_user."'");
		_ISI_DBQUERY ("DELETE FROM ".$inetd["dbprefix"]."log_online WHERE identity=INET_ATON('".$remote_ip."')");
	}

	/**
	 * clear an user cookie
	 *
	 * void
	 */
	function _ISI_CLEARAUTHDATA() {
		global $inetd,$_COOKIE,$_SESSION;
		setCookie($inetd["authcookie"], 'NULL', null, '/');
		unset($_COOKIE[$inetd["authcookie"]]);
		unset($_COOKIE[$inetd["authcookie"]]);
		unset($_COOKIE[session_name()]);
		unset($_COOKIE[session_name()]);
		$_COOKIE = array();
		$_SESSION = array();
	}

	/**
	 * get basic auth user info by id_user (username[0], userfake[1], usergroup[2])
	 *
	 * return array of strings
	 */
	function _ISI_GETUSER_AUTHINFO($in_id) {
		global $inetd;
		$reply = _ISI_DBQUERY("SELECT memberName, realName, ".$inetd["dbprefix"]."groups_principal.membergroup, emailAddress
							FROM ".$inetd["dbprefix"]."members
							JOIN ".$inetd["dbprefix"]."groups_principal
							ON ".$inetd["dbprefix"]."members.memberGroup = 
								".$inetd["dbprefix"]."groups_principal.ID_GROUP
							WHERE ID_MEMBER='".$in_id[0]."'");
		return array(true, $reply);
	}

	/**
	 * assign locale to database
	 *
	 * void
	 */
	function _ISI_SETLOCALE_DB($in_data) {
		global $inetd, $id_user;
		$inlocale = $in_data[0];
		if ($id_user != 'Guest') {
	 		switch ($inlocale) {
	 			case "en_GB":
		 			$inlocale = "english.lng";
	 				break;
	 			case "it_IT":
		 			$inlocale = "italian.lng";
	 				break;
	 			default:
		 			$inlocale = "english.lng";
	 				break;
	 		}
	 	_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members SET lngfile = '".$inlocale."'
			WHERE ".$inetd["dbprefix"]."members.ID_MEMBER = ".$id_user);
	 	}
	}

	/**
	 * reads user locale from cookie
	 *
	 * return locale string
	 */
	function _ISI_GETLOCALE_FROMCOOKIE() {
		global $inetd,$_COOKIE;
		$tmplocale = null;
		if (isset($_COOKIE))
			$cookie = $_COOKIE;
		else
			$cookie = $_COOKIE;
		if (isset($cookie[$inetd["localecookie"]]))
			$tmplocale = $cookie[$inetd["localecookie"]];
		return array(true, $tmplocale);
	}

	/**
	 * assign locale cookie
	 *
	 * void
	 */
	function _ISI_SETLOCALE_COOKIE($in_data) {
		global $inetd;
		$inlocale = $in_data[0];
		if ($inetd["cookietime"] != null) $ctime = $inetd["cookietime"];
		setCookie($inetd["localecookie"], $inlocale, $ctime, '/');
	}

	/**
	 * reads user layout from cookie
	 *
	 * return string (layout)
	 */
	function _ISI_GETLAYOUT_FROMCOOKIE() {
		global $inetd,$_COOKIE;
		if (isset($_COOKIE))
			$cookie = $_COOKIE;
		else
			$cookie = $_COOKIE;
		if (isset($cookie[$inetd["layoutcookie"]]))
		$tmplayout = $cookie[$inetd["layoutcookie"]];
		return array(true, $tmplayout);
	}

	/**
	 * assign layout cookie
	 *
	 * void
	 */
	function _ISI_SETLAYOUT_COOKIE($in_data) {
		global $inetd, $layout;
		$inlayout = $in_data[0];
		if ($inetd["cookietime"] != null) $ctime = $inetd["cookietime"];
		setCookie($inetd["layoutcookie"], $inlayout, $ctime, '/');
	}

	/**
	 * reads user template from cookie
	 *
	 * return template string
	 */
	function _ISI_GETTEMPLATE_FROMCOOKIE() {
		global $inetd,$_COOKIE;
		if (isset($_COOKIE[$inetd["templatecookie"]]))
		$tmptemplate = $_COOKIE[$inetd["templatecookie"]];
		return array(true, $tmptemplate);
	}

	/**
	 * assign template cookie
	 *
	 * void
	 */
	function _ISI_SETTEMPLATE_COOKIE($in_data) {
		global $inetd;
		$intemplate = $in_data[0];
		$ctime = time() + (60 * 60 * 24 * 365);
		setCookie($inetd["templatecookie"], $intemplate, $ctime, '/');
	}

	/**
	 * verify if a new user is creable
	 *
	 * require:
	 * _POST["username"]
	 * _POST["email"]
	 *
	 * return signal
	 */
	function _ISI_CREATEUSER_VERIFY($in_array = null) {
		global $inetd, $_POST, $_GET, $_POST, $_SERVER, $driver_txt;
		$matchword = $matchcase = $matchuser = $matchname = 0;
		$signal = array(); $signal[0] = false; $member = array();
		$user = isset($in_array[0]) ? $in_array[0] : null;
		$password = isset($in_array[1]) ? $in_array[1] : null;
		$email = isset($in_array[2]) ? $in_array[2] : null;
		$group = isset($in_array[3]) ? $in_array[3] : "1";

		if ( (trim($_POST["username"]) == '' || !isset($_POST["username"])) 
			&& ($user == null || !isset($user) || trim($user) == '') )
			$signal[1] = $driver_txt['isicms_missinguser'];

		if ( (trim($_POST["email"]) == '' || !isset($_POST["email"])) && ($email == null || !isset($email) || trim($email) == '') )
			$signal[1] = $driver_txt['isicms_missingemail'];

		$user = $user != null ? $user : $_POST["username"]; $member["user"] = $user;
		$password = $password != null ? $password : $_POST["password"]; $member["passwrd1"] = $password;
		$email = $email != null ? $email : $_POST["email"]; $member["email"] = $email;
		$group = $group != null ? $group : $_POST["group"]; $member["group"] = $group;

		foreach($_GET as $key => $value)
			$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));
		foreach($_POST as $key => $value)
			$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));


		if (strlen($member['user']) > 25)
			$member['user'] = substr($member['user'], 0, 25);
		if ($member['user'] == '')
			$signal[1] = $driver_txt['isicms_specifyusername'];
		if (!preg_match("/^[\s0-9A-Za-z#,-\.:=?@^_]+$/",$user))
			$signal[1] = $driver_txt['isicms_charsnotvalid'];
		if ($member['user'] == '_' || $member['user'] == '|')
			$signal[1] = $driver_txt['isicms_usernotalphanumeric'];
		if (strstr($member['user'], 'Guest'))
			$signal[1] = $driver_txt['isicms_reserveduser'].' '. htmlspecialchars($member['user']);
		if (!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/", $member['email']))
			$signal[1] = $driver_txt['isicms_emailnotvalid'];
		if ($member['email'] == '')
			$signal[1] = $driver_txt['isicms_voidemail'];

		$request = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members WHERE memberName = '".$member['user']."'");
		if (count($request) > 0)
			$signal[1] = $driver_txt['isicms_useralreadypresent'].' '.htmlspecialchars($member['user']);

		if ($member['passwrd1'] != null) {
			if ($member['passwrd2'] == null) $member['passwrd2'] = $member['passwrd1'];
			if ($member['passwrd1'] !=  $member['passwrd2'])
				$signal[1] = $driver_txt['isicms_passwordnotsame'];

			if ($member['passwrd1'] == '')
				$signal[1] = $driver_txt['isicms_passwordvoid'];
		}

		//Check if mail is banned
		$request = _ISI_DBQUERY("SELECT value FROM ".$inetd["dbprefix"]."banned WHERE (type='email' && value='$member[email]')");
		if (count($request) > 0)
			$signal[1] = $driver_txt['isicms_bannedemail'];
		//Check if the email address or the memberName is in use
		$request = _ISI_DBQUERY("SELECT memberName FROM ".$inetd["dbprefix"]."members WHERE emailAddress='$member[email]'");
		if (count($request) > 0)
			$signal[1] = $driver_txt['isicms_emailalreadypresent'].' '.htmlspecialchars($member[email]);
		//Check if memberName is already is use
		$request = _ISI_DBQUERY("SELECT memberName FROM ".$inetd["dbprefix"]."members WHERE memberName = '".$member['user']."'");
		if (count($request) > 0)
			$signal[1] = $driver_txt['isicms_namealreadypresent'].' '.htmlspecialchars($member['user']);
		htmlentities($member['email']);

		$row = _ISI_DBQUERY("SELECT setting,value FROM ".$inetd["dbprefix"]."reserved_names WHERE 1");
		if (count($row) > 0) {
			$reserve = array();
			for ($i = 0; $i < count($row); $i++) {
				if ($row[$i]['setting'] == 'word')
					$reserve[] = trim($row[$i]['value']);
				else
					${$row[$i]['setting']} = trim($row[$i]['value']);
			}
			$namecheck = ($matchcase == '1' ? $member['user'] : strtolower($member['user']));
			foreach ($reserve as $reserved) {
				$reservecheck = ($matchcase == '1') ? $reserved : strtolower($reserved);
				if ($matchuser == '1') {
					if ($matchword == '1') {
						if ($namecheck == $reservecheck) $signal[1] = $driver_txt['isicms_namealreadypresent'].' '.$reserved;
					}
					else {
						if (strstr($namecheck,$reservecheck)) $signal[1] = $driver_txt['isicms_reserveduser'].' '.$reserved;
					}
				}
			}
		}

		$request = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members WHERE memberName = '".$member['user']."'");
		if ($request[0][0] != null)
			$signal[1] = $driver_txt['isicms_usernameduplicate'];

		if (!isset($signal[1])) {
			$signal[0] = true;
			$signal[1] = true;
		}

		return $signal;
	}


	/**
	 * create new user function
	 *
	 * require:
	 * _POST["username"]
	 * _POST["email"]
	 *
	 * return signal
	 */
	function _ISI_CREATEUSER($in_array = null) {
		global $inetd, $_POST, $_GET, $_POST, $_SERVER, $driver_txt;
		
		$CREATEPASS = false; $SENDMAIL = false;

		$matchword = $matchcase = $matchuser = $matchname = 0;
		$signal = array(); $signal[0] = false; $member = array();
		$user = isset($in_array[0]) ? $in_array[0] : null;
		$password = isset($in_array[1]) ? $in_array[1] : null;
		$email = isset($in_array[2]) ? $in_array[2] : null;
		$group = isset($in_array[3]) ? $in_array[3] : "1";
		$groupsid = isset($in_array[4]) ? $in_array[4] : null;
		$CREATEPASS = isset($in_array[5]) ? $in_array[5] : $CREATEPASS;

		$user = $user != null ? $user : $_POST["username"]; $member["user"] = $user;
		$password = $password != null ? $password : $_POST["password"]; $member["passwrd1"] = $password;
		$email = $email != null ? $email : $_POST["email"]; $member["email"] = $email;
		$group = $group != null ? $group : $_POST["group"]; $member["group"] = $group;
		//$groupsid = $groupsid != null ? $groupsid : $_POST["groups"]; $member["groups"] = $groupsid;

		foreach($_GET as $key => $value)
			$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));
		foreach($_POST as $key => $value)
			$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));

		if ($inetd["emailpassword"] && $member["passwrd1"] == null)	{
			// randomly generate a new password
			mt_srand(time());
			$password = crypt(mt_rand(-100000, 100000));

			// remove all non alpha-numeric characters
			$password = preg_replace("/\W/", '', $password);

			//limit it to 10 characters max
			$member['passwrd1'] = substr($password, 0, 10);
		}
		$queryPasswdPart = $this->_ISI_MD5_HMAC( array($member['passwrd1'], strtolower($member['user'])) );

		$requesttime = time();
		$memIP = $_SERVER["REMOTE_ADDR"];

		//we're not using auto_increment
		$requestMAXid = _ISI_DBQUERY("SELECT MAX( ID_MEMBER ) FROM ".$inetd["dbprefix"]."members");
		$idtmp = $requestMAXid[0][0];
		if (!isset($idtmp)) $idTOuse = 1;
		else $idTOuse = ($idtmp + 1);

		if ($CREATEPASS) $userpassword = $queryPasswdPart;
		else $userpassword = '';
		
		 _ISI_DBQUERY("INSERT INTO ".$inetd["dbprefix"]."members
			(ID_MEMBER, memberName, realName, passwd, emailAddress, memberGroup, posts, personalText, avatar, dateRegistered, memberIP, im_email_notify, lngfile, firstLogin, birthdate)
			VALUES ('$idTOuse','$member[user]','$member[user]','$userpassword','$member[email]','$member[group]',0,'','blank.gif',$requesttime, '$memIP', 1, 'english.lng', 1, '2007-07-27')");

		$result = _ISI_DBQUERY("SELECT memberName,realName FROM ".$inetd["dbprefix"]."members ORDER BY dateRegistered DESC LIMIT 1");
		$latestmember  = $result[0][0];
		$latestRealName = $result[0][0];
		$result = _ISI_DBQUERY("SELECT COUNT(*) FROM ".$inetd["dbprefix"]."members;");
		$memberCount = $result[0][0];
		$request = _ISI_DBQUERY("REPLACE INTO ".$inetd["dbprefix"]."settings (variable,value)
                                						VALUES ('latestMember','$latestmember'),
																		('latestRealName','$latestRealName'),
																		('memberCount','$memberCount')");

		if ($inetd["trackStats"]) {
			$date = getdate(time() + $inetd["timeoffset"] * 3600);
			$statsquery = _ISI_DBQUERY("SELECT day, month, year FROM ".$inetd["dbprefix"]."log_activity WHERE month = $date[mon] AND day = $date[mday] AND year = $date[year]");
			if (count($statsquery) > 0)
				$statsquery = _ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."log_activity SET registers = registers + 1 WHERE month = $date[mon] AND day = $date[mday] AND year = $date[year]");
			else
				_ISI_DBQUERY("INSERT INTO ".$inetd["dbprefix"]."log_activity (month, day, year, registers) VALUES ($date[mon], $date[mday], $date[year], 1)");
		}

		if ( $inetd["emailpassword"] && $SENDMAIL) {
			_ISI_SENDMAIL($member['email'], $driver_txt['isicms_mail_subject'], 
				$driver_txt['isicms_mail_body1'].' '.$member[user]."\n".$driver_txt['isicms_mail_body2'].' '.$member['passwrd1'].' ', $driver_txt['isicms_mail_fromname']);
		}

		if (!isset($signal[1])) {
			$signal[0] = true;
			$signal[1] = $member['passwrd1'];
		}
		
		
		if ($groupsid != null) {
			$query = "SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."membergroups 
				WHERE ID_GROUP = '".$groupsid."'";
			$reply = _ISI_DBQUERY($query);
			if (!($reply[0][0] == $idTOuse)) {
				$query = "INSERT INTO ".$inetd["dbprefix"]."membergroups (ID_MEMBER,ID_GROUP)
					VALUES ('".$idTOuse."', '".$groupsid."')
					ON DUPLICATE KEY UPDATE ID_MEMBER = ID_MEMBER;";
				_ISI_DBQUERY($query);
			}
		}

		return $signal;
	}


	/**
	 * user drop verification
	 *
	 * return signal
	 */
	 function _ISI_DELETEUSER_VERIFY($in_array) {
	 	global $inetd, $driver_txt;
	 	$iduser = $in_array[0];

		$signal = array();
		$signal[0] = false;

	 	if ($iduser != null && $iduser != "Guest" && $iduser != 1) {
	 		$request = _ISI_DBQUERY("SELECT memberName FROM ".$inetd["dbprefix"]."members WHERE ID_MEMBER = '".$iduser."'");
	 		if ( !(trim($request[0][0]) != '' && $request[0][0] != null))
	 			$signal[1] = $driver_txt['isicms_usernotfound'];

	 		if (!isset($signal[1])) {
				$signal[0] = true;
				$signal[1] = true;
			}

		}
		else $signal[1] = $driver_txt['isicms_usernotvalid'];
		return $signal;
	 }

	/**
	 * user drop
	 *
	 * return signal
	 */
	 function _ISI_DELETEUSER($in_array) {
	 	global $inetd, $driver_txt;
	 	$iduser = $in_array[0];

		$signal = array();
		$signal[0] = false;

	 	if ($iduser != null && $iduser != "Guest" && $iduser != 1) {
	 		if ($inetd["deletedrop"]) _ISI_DBQUERY("DELETE FROM ".$inetd["dbprefix"]."members WHERE ID_MEMBER = '".$iduser."'");
	 		else _ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members SET passwd = '' WHERE ID_MEMBER = '".$iduser."'");
	 		$signal[0] = true;
	 		$signal[1] = true;
		}
		else $signal[1] = $driver_txt['isicms_usernotvalid'];
		return $signal;
	 }

	/**
	 * check for password requirements
	 * 
	 * @param $in_pass string
	 * @return mixed $validsignal
	 */
	function _ISI_CHECKPASS ($in_pass) {
		global $driver_txt;
		$validsignal = array(true, null);
		if (strlen($in_pass) < 8) {
			$validsignal[0] = false;
			$validsignal[1] = $driver_txt['isicms_passnotvalid_reason1'];
		}
		if ($validsignal[0])
			if (!(preg_match('/[A-Z][^A-Z]*/',$in_pass))) {
				$validsignal[0] = false;
				$validsignal[1] = $driver_txt['isicms_passnotvalid_reason2'];
			}
		if ($validsignal[0])
			if (!(preg_match('/[a-z][^a-z]*/',$in_pass))) {
				$validsignal[0] = false;
				$validsignal[1] = $driver_txt['isicms_passnotvalid_reason3'];
			}
		if ($validsignal[0])
			if (!(preg_match('#[^a-zA-Z0-9]#',$in_pass))) {
				if (!(preg_match('/[0-9][^0-9]*/',$in_pass)))  {
					$validsignal[0] = false;
					$validsignal[1] = $driver_txt['isicms_passnotvalid_reason4'];
				}
			}
		return $validsignal;
	}
	
	/**
	 * change user password
	 *
	 * @return mixed signal
	 */
	 function _ISI_CHPASS($in_array) {
	 	global $id_user, $inetd, $driver_txt;
	 	$signal = array();
		$signal[0] = false;
	 	//print_r($in_array);
	 	$iduser = $in_array[0];
	 	$inuser = $in_array[1];
	 	$newpass = $in_array[2];
	 	//echo "id: ".$iduser." user:".$inuser." pass:".$newpass."<br />";
	 	$retsignal = $this->_ISI_CHECKPASS($newpass);
	 	if ($retsignal[0] == true) {
		 	$password = $this->_ISI_MD5_HMAC(array($newpass, strtolower($inuser)) );
		 	
		 	$alreadyused = false;
		 	if ($id_user == $iduser) {
			 	$query = "SELECT passwd FROM ".$inetd["dbprefix"]."members_passwd
			 				WHERE ID_MEMBER = '".$iduser."'
							ORDER BY pwdChange DESC LIMIT 0 , 4";
				$reply = _ISI_DBQUERY($query);
				for ($i = 0; $i < count($reply); $i++) {
					if ($reply[$i]["passwd"] == $password) $alreadyused = true;
				}
		 	}

		 	if ($alreadyused) {
		 		$signal[1] = $driver_txt['isicms_passnotvalid'].': '.$driver_txt["isicms_passnotvalid_reason5"];
		 	}
		 	else {
			 	if ($id_user == $iduser) {
			 		$firstLogin = "0";
			 		$now = time();
					$query = "INSERT INTO ".$inetd["dbprefix"]."members_passwd (ID_MEMBER, passwd, pwdChange)
							VALUES ('".$iduser."', '".$password."', '".$now."');";
					_ISI_DBQUERY($query);		 		
			 	}
			 	else $firstLogin = "1";
			 	$query = "UPDATE ".$inetd["dbprefix"]."members SET passwd = '".$password."',
			 		firstLogin = '".$firstLogin."' WHERE ID_MEMBER = '".$iduser."'";
			 	//echo $query;
			 	_ISI_DBQUERY($query);
			 	$signal[0] = true;
		 		$signal[1] = true;
		 	}
	 	}
	 	else {
	 		$signal[1] = $driver_txt['isicms_passnotvalid'].': '.$retsignal[1];
	 	}
	 	//print_r($signal);
	 	return $signal;
	 }

	 /**
	  * change user password and if old one is correct
	  *
	  * @return mixed signal
	  */
	 function _ISI_CHPASS_WITHCHECKOLDPASS($in_array) {
	 	global $id_user, $inetd, $driver_txt;
	 	$signal = array();
	 	$signal[0] = false;
	 	/*$iduser = $in_array[0];
	 	$inuser = $in_array[1];
	 	$oldpass = $in_array[2];
	 	$newpass = $in_array[3];*/
	 	$chpassarray = array();
	 	$chpassarray[0] = $in_array[0];
	 	$chpassarray[1] = $in_array[1];
	 	$chpassarray[2] = $in_array[3];
	 	$validatearray = array();
	 	$validatearray[0] = $in_array[1];
	 	$validatearray[1] = $in_array[2];
	 	$disabledatearray = array();
	 	$disabledatearray[0] = $in_array[1];
	 	$tmp1 = $this->_ISI_ISDISABLEDUSER($disabledatearray);
	 	$isdisabled = $tmp1[1];
	 	$tmp2 = $this->_ISI_VALIDATEUSER($validatearray);
	 	$isvalid = $tmp2[1];
	 	if ($isdisabled) return $this->_ISI_CHPASS($chpassarray);
	 	elseif ($isvalid) return $this->_ISI_CHPASS($chpassarray);
		else {
			$signal[1] = $driver_txt['isicms_oldpassnotvalid'];
			return $signal;
	 	}
	 }
	 
	/**
	 * change user email
	 *
	 * void
	 */
	 function _ISI_CHEMAIL($in_array) {
	 	global $inetd, $driver_txt;
		$signal = array();
		$signal[0] = true;
	 	$iduser = $in_array[0];
	 	$newemail = $in_array[1];
	 	$query = "SELECT emailAddress FROM ".$inetd["dbprefix"]."members WHERE ID_MEMBER = '".$iduser."'"; 
	 	$req = _ISI_DBQUERY($query);
	 	
		$oldmail = $req[0][0];
		if ($oldmail != $newemail) {
		 	$request = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members WHERE emailAddress = '".$newemail."'");
			if (count($request) > 0) {
				$signal[0] = false;
				$signal[1] = $driver_txt['user_emailalreadypresent'];
			}
			else {
				$query = "UPDATE ".$inetd["dbprefix"]."members SET emailAddress = '".$newemail."' WHERE ID_MEMBER = '".$iduser."'";
				_ISI_DBQUERY($query);
			}
		}
		return $signal;
	 }
	 
	/**
	 * create new random password for a user
	 * 
	 * array(pass, md5(pass)) 
	 */
	function _ISI_CREATE_RDMPASS($in_array) {
		$username = $in_array[0];
		
		// randomly generate a new password
		mt_srand(time());
		$password = crypt(mt_rand(-100000, 100000));
	
		// remove all non alpha-numeric characters
		$password = preg_replace("/\W/", '', $password);
	
		//limit it to 10 characters max
		$pass = substr($password, 0, 10);
		$queryPasswdPart = $this->_ISI_MD5_HMAC( array($pass, strtolower($username)) );
		
		$return = array(); $return[0] = $pass; $return[1] = $queryPasswdPart;
		$signal = array(); $signal[0] = true; $signal[1] = $return;
		return $signal;
	}
	
	
	/**
	 * send mail with password to user
	 */
	function _ISI_SEND_PASSMAIL($in_array) {
		global $driver_txt;
		$mail = $in_array[0];
		$username = $in_array[1];
		$password = $in_array[2];
		
		_ISI_SENDMAIL($mail, $driver_txt['isicms_mail_subject'], 
			$driver_txt['isicms_mail_body1'].' '.$username."\n".$driver_txt['isicms_mail_body2'].' '.$password.' ', $driver_txt['isicms_mail_fromname']);
	}
}
?>
