<?php

require_once ('h4language.php');

class form
{
	public $_name			 = null;
	private $_method		 = null;
	private $_action		 = null;
	private $_formIdentifier = null;
	private $_lang			 = null;
	private $_language		 = null;
	private $_id			 = null;
	private $_javascript	 = null;
	private $_enchtype		 = null;
	private $_target		 = null;
	private $_label			 = null;
	private $_attributes	 = null;

	private $_arrayInputs	 = null;
	private $_arraySection   = null;
	private $_arrayHiddens   = null;
	private $_arraySubmits   = null;

	private $_align			 = null;
	private $_width			 = null;
	private $_valid			 = null;
	private $_cols			 = null;
	private $_viewNote		 = null;
	private $_viewRequired	 = null;
	private $_columnsWidth	 = null;
	private $_globalNote	 = null;
	private $_errorNote	 	 = null;

	public  $_code 			 = null;

	public function __construct ($name,$method){
		global $hikariFormLanguage;

		$this->_method = $method;
		$this->_name = $name;
		$this->_action = $_SERVER['REQUEST_URI'];
		$this->_formIdentifier = 'htmlformidentifier';
		$this->_valid = true;
		$this->_cols = 1;
		$this->_viewNote = false;
		$this->_viewRequired = true;
		$this->_width = 640;
		$this->_setAttributes = '';
		$this->_lang = 'ita';
		$this->_language = $hikariFormLanguage[$this->_lang];

		//Array Initialization
		$this->_arrayHiddens = array();
		$this->_arrayCustoms = array();
		$this->_arraySubmits = array();
		$this->_arraySections = array();
		$this->_globalNote = array();

		//Creating the Default Section
		$section = new section('default');
		$section->viewLabel(false);
		$section->viewDescription(false);
		$this->_arraySection['default'] = $section;
	}

	public function setIdentifier ($name){
		$this->_formIdentifier = $name;
	}

	public function setWidth($width){
		$this->_width = $width;
	}

	public function setAlign ($align){
		$this->_align = $align;
	}

	public function setLanguage($lang){
		global $hikariFormLanguage;
		
		// patch by rio
		//if ($this->_lang != "eng") {
			$this->_lang = $lang;
			$this->_language = $hikariFormLanguage[$lang];
		//}
	}

	public function setId ($id) {
		$this->_id = $id;
	}

	public function setMethod ($method){
		$this->_method = $method;
	}

	public function setAction ($action){
		$this->_action = $action;
	}

	public function setAttributes ($attributes){
		$this->_javascript = $attributes;
	}

	public function setTarget ($target){
		$this->_target = $target;
	}

	public function setEnctype ($ench){
		$this->_enchtype = $ench;
	}

	public function viewNote ($bol){
		$this->_viewNote = ($bol)?true:false;
	}

	public function viewRequired ($bol){
		$this->_viewRequired = ($bol)?true:false;
	}

	public function setValid ($bol){
		$this->_valid = $bol;
	}
    
    public function forceValid($inputName,$bol,$errorNote = null){    	
        foreach ($this->_arraySection as $sectionName => $section) {
            $section->forceValid($inputName,$bol,$errorNote);
        }
    }
    
    public function changeRequired($inputName,$bol){      
        foreach ($this->_arraySection as $sectionName => $section) {
            $section->changeRequired($inputName,$bol);
        }
    }

	public function isValid(){
		return $this->_valid;
	}

	public function getForm() {
		return $this;
	}

	public function addGlobalNote ($str){
		if ($this->_globalNote)
		if (in_array ($str,$this->_globalNote))
		return;
		$this->_globalNote[] = $str;
	}

	public function addErrorNote($str){
		if ($this->_errorNote)
			if (in_array ($str,$this->_errorNote))
				return;
		$this->_errorNote[] = $str;
	}

	//******************************** AGGIUNTA E RIEMPIMENTO ************************//

	function fillContents($datas){
		//Passo ad ogni sezione la POST affinch? riempia i propri figli
		foreach ($this->_arraySection as $sectionName => $section) {
			$section->fillContents($datas);
		}
	}

	//Insert the Input
	public function addContents($input){
		//$input->_setLanguage($this->lang); //Set the language of input

		switch ($input->getType()){
			case 'hidden': $this->_arrayHiddens[] = $input; break;
			case 'button': if ($input->_bottom) $this->_arraySubmits[] = $input;
			else $this->_arraySection[$input->_section]->addInput($input);
			break;
			case 'javaReset': $input->_setForm($this->_name);
			case 'reset':
			case 'submit': $this->_arraySubmits[] = $input; break;
			case 'section': $this->_arraySection[$input->_name] = $input; break;
			/*
			 case 'columns': $this->_colums[] = $input->name;
			 $this->attributes .=' onSubmit="selectAllInColumns(\''.$input->name.'\');"';
			 $this->arraySections[$input->section]['contents'][$input->name] = $input;
			 break;
			 */
			case 'file': self::setEnctype('multipart/form-data');
			default: $this->_arraySection[$input->_section]->addInput($input);
		}

	}

	//******************************** VALIDAZIONE *********************************//
	public function validate(){
		$this->_valid = 1; //Resetting the validation of Form. Every form starts as true.
		foreach ($this->_arraySection as $section){
			if (!$section->validate())
			   $this->_valid = 0;
		}		
	}
    
    public function whoIsInvalid(){
        $invalidInputs = array();
        foreach ($this->_arraySection as $section){
            $invalidInputs = array_merge ($invalidInputs,$section->whoIsInvalid());            
        }
        return $invalidInputs;
    }

	//******************************** STAMPA DEL CODICE *********************************//

	private function __buildSections(){
		$code = '';
		foreach ($this->_arraySection as $name=>$section){
			if ($section->hasInputs()){
				$code .= $section->getCode();
			}
		}
		return $code;
	}

	private function __buildNotes(){
		$template ='<fieldset class="formNote" style="margin-bottom:5px;">
				    	<legend>Note</legend>
				    	<div class="formDescription">[[notes]]</div>
				     </fieldset>';

		$code = '';
		if (!empty($this->_globalNote))
		foreach ($this->_globalNote as $note){
			$code .= $note.'<br/>';
		}

		if (!empty($this->_errorNote))
		foreach ($this->_errorNote as $note){
			$code .= '<span style="color:red;">'.$note.'</span><br/>';
		}

		return str_replace ('[[notes]]',$code,$template);
	}

	private function __buildSubmits(){
		$template = '<div class="formSubmits" style="text-align:right;">[[submit]]</div>';
		$code = '';
		foreach ($this->_arraySubmits as $submit){
			$code .= $submit->getCode().'&nbsp;';
		}
		return str_replace ('[[submit]]',$code,$template);
	}

	private function __buildHiddens(){
		$code = '';
		foreach ($this->_arrayHiddens as $input){
			$code .= $input->getCode();
		}
		return $code;
	}

	private function __buildForm(){
		//Inserisco la nota globale sui campi obbligatori.
		//Devo farla qua per evitare di averla scritta con una lingua diversa da quella impostata
		//self::addGlobalNote($this->_language['requiredNote']);

		$this->_code = '';
		$this->_code .= '<div id="formImagePrewiew" style="position:absolute;display:none;">&nbsp;</div>';
		$this->_code .= '<form name="'.$this->_name.'" method="'.$this->_method.'" action="'.$this->_action.'"';
		if ($this->_enchtype) $this->_code.= ' enctype="'.$this->_enchtype.'"';
		if ($this->_target) $this->_code.= ' target="'.$this->_target.'"';
		if ($this->_attributes) $this->_code .=' '.$this->_attributes;
		$this->_code .=' >';
		$this->_code .='<input type="hidden" name="trigger" value="'.$this->_formIdentifier.'" />';
		$this->_code .='<input type="hidden" name="'.$this->_formIdentifier.'" value="'.$this->_name.'" />';
		$this->_code .='<input type="hidden" name="doaction" value="1" />';
		$this->_code .= self::__buildHiddens();
		$this->_code .='<div style="width:'.$this->_width.'px;float:left;">';
		if ($this->_viewNote)
			$this->_code .= self::__buildNotes();
		$this->_code .= self::__buildSections();
		if ($this->_viewRequired)
			$this->_code .= '<div style="padding-left:15px;">'.$this->_language['requiredNote'].'</div>';
		$this->_code .= self::__buildSubmits();
		$this->_code .= '</div>';
		$this->_code .= '</form>';

	}

	public function getCode(){
		self::__buildForm();
		return $this->_code;
	}

	public function setSpecialData($data){
		foreach ($this->_arraySection as $name=>$section){
			$section->setSpecialData($data);
		}
	}

}

/***********************************************************************/
/***************************** SECTION *********************************/
/***********************************************************************/

class section
{

	public  $_name        = null;
	public  $_type        = null;

	private $_legend      = null;
	private $_description = null;
	private $_widthCols   = null;
	private $_width 	  = null;
	private $_valid		  = null;
	private $_viewLabel	  = null;
	private $_viewDes     = null;
	private $_viewNote    = null;
	private $_mid		  = null;
	private $_style		  = null;

	private $_myInputs    = null;
	private $_code        = null;
	private $_inputsCode  = null;

	private $_lang 		  = null;

	function __construct($name,$legend = '', $description = ''){
		$this->_name = $name;
		$this->_legend = (empty($legend)) ? $name : $legend;
		$this->_description = $description;
		$this->_viewDes = false;
		$this->_type = 'section';
		$this->_widthCols = array(40,60);
		$this->_myInputs = array();
		$this->_valid = true;
		$this->_viewLabel = true;
	}

	public function setLanguage($lang){
		$this->_lang = $lang;
	}
	
	public function changeRequired ($inputName,$bol){
		if (array_key_exists($inputName,$this->_myInputs))      
          $this->_myInputs[$inputName]->setRequired($bol);
	}
    
    public function forceValid($inputName,$bol,$error=null){    	
    	if (array_key_exists($inputName,$this->_myInputs)){
        	$this->_myInputs[$inputName]->forceValid($bol,$error);
    	}
    }
    
	public function setWidthCols($info,$content){
		$this->_widthCols = array($info,$content);
	}
	
	public function setId($id){
		$this->_mid = $id;
	}
	
	public function setStyle($s){
		$this->_style = $s;
	}

	public function hasInputs(){
		if (count($this->_myInputs) == 0)
		return false;
		return true;
	}

	public function getType(){
		return $this->_type;
	}

	public function isValid(){
		return $this->_valid;
	}

	public function setLabel($label){
		self::setDescription($label);
	}

	public function setDescription($description){
		$this->_description = $description;
	}

	public function viewLabel($label){
		$this->_viewLabel = $label;
	}

	public function viewDescription($des){
		$this->_viewDes = $des;
	}

	public function addInput($input){
		$this->_myInputs[$input->_name] = $input;
	}

	public function fillContents($data){
		foreach ($this->_myInputs as $inputName=>$input){
			if (array_key_exists($inputName,$data)){				
				$this->_myInputs[$inputName]->setValue($data[$inputName]);
			}
		}
	}

	public function validate(){
		foreach ($this->_myInputs as $inputName=>$input){
			$input->setValid(1);
			if (!$input->validate())
			$this->_valid = 0;
		}
		return $this->_valid;
	}
    
    public function whoIsInvalid(){
        $invalidInputs = array();
        foreach ($this->_myInputs as $inputName=>$input){            
            if (!$input->validate())
                $invalidInputs[] = $inputName;
        }
        return $invalidInputs;        
    }

	private function __buildContents(){
		$template = '<div class="container" style="position:relative;width:100%;float:left;">[[code]]</div>';
		foreach ($this->_myInputs as $input) {
			$input->setWidthCols($this->_widthCols[0],$this->_widthCols[1]);
			$this->_inputsCode .= str_replace ('[[code]]',$input->getCode($this->_widthCols),$template);
		}
	}


	public function getCode(){
		self::__buildContents();
		if ($this->_viewLabel) {
			$template = '<fieldset id="'.$this->_mid.'" style="[[sstyle]]">[[legend]][[description]][[inputs]]</fieldset>';
			$this->_code = str_replace ('[[legend]]','<legend>'.$this->_legend.'</legend>',$template);
			$this->_code = str_replace ('[[sstyle]]',$this->_style,$this->_code);
			if ($this->_viewDes)
				$this->_code = str_replace ('[[description]]','<div class="sectionDescription">'.$this->_description.'</div>',$this->_code);
			else
				$this->_code = str_replace ('[[description]]','',$this->_code);

			$this->_code = str_replace ('[[inputs]]',$this->_inputsCode,$this->_code);
			return $this->_code;
		}
		$this->_code = $this->_inputsCode;
		return $this->_code;

	}

	public function setSpecialData($data){
		if (empty($data)) return;
		foreach ($data as $info){
			if (array_key_exists($info[0],$this->_myInputs)){
				$this->_myInputs[$info[0]]->forceValid($info[1]);
				$this->_myInputs[$info[0]]->setError($info[2]);
			}
		}
	}

}

/***********************************************************************/
/***************************** INPUT ***********************************/
/***********************************************************************/

class input
{
	public  $_section        = 'default';
	public  $_name		     = null;
	public  $_type		     = null;

	protected $_label		 = null;
	protected $_class		 = null;
	protected $_cssClass     = null;
	protected $_id		     = null;
	protected $_mId          = null;
	protected $_mStyle       = null;
	protected $_value        = null;
	protected $_style        = null;
	protected $_javascript   = null;

	protected $_error		 = null;
	protected $_valid		 = null;
	protected $_forceValid	 = null;
	protected $_required     = null;
	protected $_disabled     = null;
	protected $_readonly	 = null;
	protected $_readonlyNote = null;

	protected $_viewLabel	 = null;
	protected $_lang		 = null;
	protected $_language	 = null;

	protected $_labelContent = null;
	protected $_bodyContent  = null;
	protected $_widthCols    = null;

	protected $_note		 = null;
	
	protected $_printed = null; //this flag is necessary during the drawing of Inputs. It tells if input has been printed

	public function __construct ($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL,$cssClass = NULL){
		global $hikariFormLanguage;
		// patch by rio
		global $locale;
		
		$this->_name = $name;
		$this->_label = $name;
		if ($label) $this->_label = $label;
		if ($id) $this->_id = $id;
		if ($value) $this->_value = $value;
		if ($style) $this->_style = $style;
		if ($javascript) $this->_javascript = $javascript;
		if ($error) $this->_error = $error;
		if ($cssClass) $this->_cssClass = $cssClass;

		$this->_required = false;
		$this->_error = '';
		$this->_disabled = false;
		$this->_readonly = false;
		$this->_viewLabel = true;
		$this->_colSpan = 1;
		$this->_valid = true;
		$this->_forceValid = -1;

		$this->_printed = false;
		$this->_formColums = 1;
		$this->_lang = 'ita';
		// patch by rio
		if ($locale == "en_GB") $this->_lang = 'eng';
		$this->_language = $hikariFormLanguage[$this->_lang];
	}

	public function viewLabel($bol){
		$this->_viewLabel = $bol;
	}

	public function reset(){
		$this->_value = null;
	}
    
    function setMasterId($id){
        $this->_mId = $id;
    }
    
    function setMasterStyle($style){
        $this->_mStyle = $style;
    }

	public function getViewLabel(){
		return $this->_viewLabel;
	}

	public function setLanguage($lang){
        global $hikariFormLanguage;
       	$this->_lang = $lang;
		$this->_language = $hikariFormLanguage[$lang];
	}

	public function setWidthCols($info,$content){
		$this->_widthCols = array($info,$content);
	}

	public function setId($id){
		$this->_id = $id;
	}

	public function setValue ($value){
        if (strlen($value)==0) return;
		$this->_value = stripslashes($value);
	}

	public function setValid ($bol){
		$this->_valid = $bol;
	}

	public function forceValid ($bol,$error){
		$this->_forceValid = $bol;
        if (!is_null($error)) $this->_error = $error;
	}

	public function setName($name){
		$this->_name = $name;
	}

	public function setSection ($section){
		$this->_section = $section;
	}

	public function setLabel($label){
		$this->_label = '<b>'.$label.'</b>';
	}

	public function setClass($class){
		$this->_class = $class;
	}
	
	public function setReadOnlyNote($rNote){
		$this->_readonlyNote = $rNote;
	}
	
  public function setCssClass($cssClass){
    $this->_cssClass = $cssClass;
  }

	public function setType($type){
		$this->_type = $type;
	}

	public function setStyle($style){
		$this->_style = $style;
	}

	public function setAttributes($javascript){
		$this->_javascript = $javascript;
	}

	public function setError ($error){
		$this->_arrayNote['error'] = $error;
	}

	public function setNote ($note){
		$this->_note = (empty($note)) ? null : $note;
	}

	public function setRequired($bol){
		$this->_required = $bol;
	}

	public function setDisabled($bol){
		$this->_disabled = $bol;
	}

	public function setReadonly($bol){
		$this->_readonly = $bol;
	}

	public function isNote(){
		if (is_null($this->_note))
		return false;
		return true;
	}

	public function isRequired(){
		return ($this->_required);
	}

	public function isReadOnly(){
		return ($this->_readonly);
	}

	public function isDisabled(){
		return ($this->_disabled);
	}

	public function isValid(){
		if (!$this->_forceValid) return false;
		return $this->_valid;
	}

	public function validate(){
		if (!$this->_forceValid) return false;
		return $this->_valid;
	}

	public function getName(){
		return $this->_name;
	}

	public function getLabel(){
		return $this->_label;
	}

	public function getType(){
		return $this->_type;
	}

	public function getError(){
		return $this->_error;
	}

	public function getNote(){
		return $this->_note;
	}

	public function getValue(){
		return $this->_value;
	}

	protected function __buildBaseCode(){

		$template = '<div id="[[mid]]" class="inputContainer" [[mstyle]]>
							<div class="inputInfo" style="width:[[infowidth]]%;">
								<label>[[label]]</label>
							</div>
							<div class="inputContent" style="width:[[contentwidth]]%;">
								[[inputcode]]
								[[notecode]]
								[[specificcode]]
								[[errorcode]]
							</div>
						</div>
					';

		$templateNote = '<div class="inputNote">[[note]]</div>';
		$noteCode = str_replace ('[[note]]',$this->_note,$templateNote);

		$templateError = '<div class="inputError">Error: [[error]]</div>';
        
		$errorCode =  str_replace ('[[error]]',((strlen($this->_error) == 0) ? $this->_language['genError'] : $this->_error),$templateError);

		if ($this->_required) $this->_label = $this->_label.'*';
                
		$this->_code = str_replace ('[[label]]',(($this->_viewLabel) ? $this->_label : ''),$template);
        
        $this->_code = str_replace ('[[mid]]',$this->_mId,$this->_code);
        $this->_code = str_replace ('[[mstyle]]',$this->_mStyle,$this->_code);        

		$this->_code = str_replace ('[[infowidth]]',$this->_widthCols[0]-1,$this->_code);
		$this->_code = str_replace ('[[contentwidth]]',$this->_widthCols[1]-1,$this->_code);

		$replace = (!is_null($this->_note)) ? $noteCode : '';
		$this->_code = str_replace ('[[notecode]]',$replace,$this->_code);

		$replace = ((strlen($this->_language['genError'])>0) && ( (!$this->_valid) || (!$this->_forceValid)) )? $errorCode : '';
		$this->_code = str_replace ('[[errorcode]]',$replace,$this->_code);

		$templateSpecific = '<div class="inputSpecific">[[specific]]</div>';
		$replace = str_replace ('[[specific]]','',$templateSpecific);
		if ($this->_readonly) $replace = str_replace ('[[specific]]',($this->_readonlyNote != null) ? $this->_readonlyNote : $this->_language['readonly'],$templateSpecific);
		if ($this->_disabled) $replace = str_replace ('[[specific]]',$this->_language['disabled'],$templateSpecific);

		$this->_code = str_replace ('[[specificcode]]',$replace,$this->_code);
	}

	public function getCode(){
		self::__buildBaseCode();

		$templateCode = '<input id="[[id]]" type="[[type]]" value="[[value]]" name="[[name]]" [[style]] [[javascript]] [[readonly]] [[disabled]]/>';

		$code = str_replace ('[[type]]',$this->_type,$templateCode);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[name]]',$this->_name,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);
		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
		$code = str_replace ('[[readonly]]',$ro,$code);
		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
		$code = str_replace ('[[disabled]]',$di,$code);
		return str_replace ('[[inputcode]]',$code,$this->_code);
	}

}
/***********************************************************************/
/************************** INPUT TYPE *********************************/
/***********************************************************************/
/***********************************************************************/
class text extends input
{
	protected $_size 	= null;
	protected $_maxSize	= null;

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'text';
		$this->_size = 20;
	}

	public function setSize($size){
		$this->_size = $size;
	}
	
	public function setMaxSize($size){
		$this->_maxSize = $size;	
	}

	public function validate(){
		if (count($this->_value) > 1) $isarray = true;   
		if ($this->_readonly) return true;
		if (!$this->_forceValid) return false;
		if ($this->_forceValid > 0) return true;
		if ($isarray) {
			for ($i = 0; $i < count($this->_value); $i++)
				if (($this->_required) && (strlen($this->_value[$i]) == 0)) {
					$this->_valid = false;
            		return false;
				} 
		}
		elseif (($this->_required) && strlen($this->_value) == 0){
            $this->_valid = false;
            return false;
		}
		return true;
	}

	public function getCode(){
		self::__buildBaseCode();
				

		$templateCode = '<input id="[[id]]" type="[[type]]" size="[[size]]" value="[[value]]" name="[[name]]" [[style]] [[max]] [[javascript]] [[readonly]] [[disabled]]/>';

		$code = str_replace ('[[type]]',$this->_type,$templateCode);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$code = str_replace ('[[size]]',$this->_size,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[name]]',$this->_name,$code);		
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);
		$maxCode = (is_null($this->_maxSize)) ? '':'maxlength = "'.$this->_maxSize.'"';
		$code = str_replace ('[[max]]',$maxCode,$code);
		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
		$code = str_replace ('[[readonly]]',$ro,$code);
		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
		$code = str_replace ('[[disabled]]',$di,$code);
		return str_replace ('[[inputcode]]',$code,$this->_code);
	}

}

class hidden extends text
{
	function __construct($name, $value){
	    parent::__construct($name, $value);
		$this->_type = 'hidden';
		$this->_value = $value;
		$this->_name = $name;
	}

	public function validate(){
		$this->_valid = true;
		return true;
	}
		
	public function getCode(){
		//self::__buildBaseCode();

		$templateCode = '<input id="[[id]]" type="[[type]]" value="[[value]]" name="[[name]]" />';

		$code = str_replace ('[[type]]',$this->_type,$templateCode);
		$code = str_replace ('[[value]]',$this->_value,$code);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$code = str_replace ('[[name]]',$this->_name,$code);
		return $code;
	}

}

class password extends text
{
	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'password';
	}
}

class email extends text
{

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'text';
		$this->_arrayNote['error'] = 'Mail Errata';
	}

	public function validate(){
		$this->_valid = false;
		if (!parent::validate()) return false;
		if (!$this->_required && $this->_value == '') {
			$this->_valid = true;
			return $this->_valid;
		}
				
		if (preg_match('/^[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9-_]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$/',trim($this->_value)))
			$this->_valid = true;
		else{
			$this->_error = $this->_language['emailnonvalida'];
			$this->_valid = false;
		}		
		
		return $this->_valid;
	}

}

class numeric extends text
{

	protected $_size = null;
	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'text';
		$this->_size = 20;
		$this->_arrayNote['error'] = 'Inserire solo numeri';
	}
	
	public function validate(){
		$this->_value = str_replace ('-','',$this->_value);
		$this->_value = str_replace ('.','',$this->_value);
        if (!parent::validate())
            return $this->_valid;        
		preg_match('/[^0-9,]/',$this->_value,$trovati);
		if (!empty($trovati)) 
			$this->_valid = false;			
		
		return $this->_valid;
	}

}

class submit extends input
{
	
	private $tt = null;
	
	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL,$cssClass=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL,$cssClass);
		$this->_type = 'submit';
		$this->_value = $name;
	}

	public function validate(){
		if (!$this->_forceValid) return false;
		return true;
	}
	
	public function getCode(){
		self::__buildBaseCode();

		$templateCode = '<input id="button" type="[[type]]" class="[[class]]" name="[[name]]" value="[[value]]" style="[[style]]" [[javascript]]/>';
		$code = str_replace ('[[name]]',$this->_name,$templateCode);
		$code = str_replace ('[[type]]',$this->_type,$code);
		$code = str_replace ('[[class]]',$this->_tt,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);

		return $code;
	}

}

class reset extends submit
{

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'reset';
	}
}

class button extends input
{

	public $_bottom = null;

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'button';
		$this->_bottom = false;
	}

	public function getCode(){

		$templateCode = '<input type="[[type]]" name="[[name]]" value="[[value]]" class="[[class]]" style="[[style]]" [[javascript]] />';

		$code = str_replace ('[[name]]',$this->_name,$templateCode);
		$code = str_replace ('[[type]]',$this->_type,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);
		$code = str_replace ('[[class]]',$this->_class,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);

		return $code;
	}

	public function setBottom($bol){
		$this->_bottom = $bol;
	}

}

class singleCheck extends input
{
	private $_checked = false;
	
	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'checkbox';
		$this->_align = 'vertical';
	}
	
	function setItem($name,$value,$checked=false,$id=null){
		$this->_name = $name;
		$this->_value = $value;
		$this->_checked = $checked;
		$this->_id = $id;
		
	}
	
	function setValue($checked){
		$this->_checked = $checked;
	}
	
	function validate(){
		return true;
	}
	
	public function getCode(){
		self::__buildBaseCode();
	
		$templateCode = '<div><input id="[[id]]" type="checkbox" value="[[value]]" name="[[name]]" [[checked]] [[style]] [[javascript]] [[readonly]] [[disabled]]/></div>';
		$code = str_replace('[[id]]',$this->_id,$templateCode);
		$code = str_replace('[[value]]',$this->_value,$code);
		$code = str_replace('[[name]]',$this->_name,$code);
		$code = str_replace('[[checked]]',(($this->_checked) ? 'checked="checked"':""),$code);
		$code = str_replace('[[style]]',$this->_style,$code);
		$code = str_replace('[[javascript]]',$this->_javascript,$code);
		$code = str_replace('[[readonly]]',$this->_readonly,$code);
		$code = str_replace('[[disabled]]',$this->_disabled,$code);
		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);
		return $this->_code;
	}
	
}

class checkbox extends input
{

	protected $_arrayItems = null;
	protected $_align = null;
	protected $_viewText = null;

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'checkbox';
		$this->_arrayItems = array ();
		$this->_align = 'vertical';
		$this->_viewText = true;        
	}

	function addItem ($name,$value,$checked=false,$id=NULL){
		$this->_arrayItems[$name] =  array ('name'=>$name,
										    'value'=>$value,
										    'checked'=>$checked,
										    'id'=>$id);		
	}

	//Controlla se una specifica opzione ? all'interno
	public function isInside($name){
		return array_key_exists ($name,$this->_arrayItems);
	}

	public function setAlign($align){
		$this->_align = $align;
	}
	
	public function viewText($bol){
		$this->_viewText = $bol;
	}

	//Controlla se almeno uno dei check ? checcato
	protected function __checkChecked(){
		foreach ($this->_arrayItems as $key=>$value)
		  if ($value['checked'])
		      return true;
		return false;
	}

	public function validate(){
		if (!$this->_forceValid) {
			$this->_valid = false;
			return $this->_valid;
		}
		$this->_valid = false;
		if (($this->_disabled) || (!$this->_required)){
			$this->_valid = true;
		}
		elseif ( ($this->_required) && (self::__checkChecked()) ){
			$this->_valid = true;
		}
		return $this->_valid;
	}

	protected function __reset() {
		foreach ($this->_arrayItems as $key=>$value)
		  $this->_arrayItems[$key]['checked'] = false;
	}


	public function setValue($checkboxs){
		self::__reset();
		
	    if (is_numeric($checkboxs)){
				$this->_arrayItems[$this->_name]['checked'] = ($checkboxs) ? true : false;
			}
			elseif (is_array($checkboxs))
			  foreach ($checkboxs as $key=>$value)
			      $this->_arrayItems[$key]['checked'] = true;
			  else
	    		foreach ($this->_arrayItems as $name => $data) {
	    			if ($data['value'] == $checkboxs) {
	    				$this->_arrayItems[$name]['checked'] = true;
	    				break;
	    			}
	    		}
	}

	public function getCode(){
		self::__buildBaseCode();

		$newPara = ($this->_align == 'horizzontal') ? '' : '<br />';
		$templateCode = '<div><input id="[[id]]" type="[[type]]" value="[[value]]" name="[[name]]" [[checked]] [[style]] [[javascript]] [[readonly]] [[disabled]]/> &nbsp;[[label]]</div>';

		$code = '';
		foreach ($this->_arrayItems as $name=>$item){
			if (count($this->_arrayItems))
			     $fCode = str_replace ('[[name]]',$this->_name.'[--value--]',$templateCode);
			else
    			$fCode = str_replace ('[[name]]',$this->_name,$templateCode);
			
            $fCode = str_replace ('[[type]]',$this->_type,$fCode);
    		$fCode = str_replace ('[[javascript]]',$this->_javascript,$fCode);
    		$fCode = str_replace ('[[value]]',$item['value'],$fCode);
    		$fCode = str_replace ('--value--',$item['name'],$fCode);
    		$fCode = str_replace ('[[label]]',(($this->_viewText) ? $item['name'] : ''),$fCode);    	
    		$fCode = str_replace ('[[checked]]',(($item['checked']) ? 'checked="checked"' : ''),$fCode);
    		$fCode = str_replace ('[[id]]',$item['id'],$fCode);
    		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
    		$fCode = str_replace ('[[readonly]]',$ro,$fCode);
    		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
    		$fCode = str_replace ('[[disabled]]',$di,$fCode);
    		$fCode .= $newPara;
    		$code .= $fCode;
		}

		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);

		return $this->_code;
	}

}

class radio extends checkbox
{

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'radio';
	}

	public function setValue($data){		
        self::__reset();
        if ($data == null){
        	return;
        }
		if (is_array($data)){
            $key = array_keys($data);
		    $this->_arrayItems[$key[0]]['checked'] = true;
        }
		else{
			foreach ($this->_arrayItems as $key=>$info)
				if ($info['value'] == $data){
					$this->_arrayItems[$key]['checked'] = true;
					break;
				} 
		}
		
		  
	}
	
	public function getCode(){
		self::__buildBaseCode();

		$newPara = ($this->_align == 'horizzontal') ? '' : '<br />';
		$templateCode = '<div><input id="[[id]]" type="[[type]]" value="[[value]]" name="[[name]]" [[checked]] [[style]] [[javascript]] [[readonly]] [[disabled]]/> &nbsp;[[label]]</div>';

		$code = '';
		foreach ($this->_arrayItems as $name=>$item){
			$fCode = str_replace ('[[name]]',$this->_name,$templateCode);    		
            $fCode = str_replace ('[[type]]',$this->_type,$fCode);
    		$fCode = str_replace ('[[javascript]]',$this->_javascript,$fCode);
    		$fCode = str_replace ('[[value]]',$item['value'],$fCode);    		
    		$fCode = str_replace ('[[label]]',(($this->_viewText) ? $item['name'] : ''),$fCode);    		
    		$fCode = str_replace ('[[checked]]',(($item['checked']) ? 'checked="checked"' : ''),$fCode);
    		$fCode = str_replace ('[[id]]',$item['id'],$fCode);
    		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
    		$fCode = str_replace ('[[readonly]]',$ro,$fCode);
    		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
    		$fCode = str_replace ('[[disabled]]',$di,$fCode);
    		$fCode .= $newPara;
    		$code .= $fCode;
		}

		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);

		return $this->_code;
	}


}

class select extends input
{

	private $_multiple = null;
	private $_size = null;
	private $_arrayItems = null;
	private $_count = 0;
	private $_hash = null;
	private $_checked = null;
	private $_piece = null;
	private $_width = null;

	function __construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL){
		parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
		$this->_type = 'select';
		$this->_arrayItems = array();
		$this->_hash = array();
		$this->_multiple = false;
		$this->_size = 1;
		$this->_piece = '';
	}

	//Aggiungo un elemento alla lista
	public function addItem ($label=null,$value=null,$settato=NULL,$id=NULL,$javascript=NULL,$readonly = null,$disabled = null){
    	$keyLabel = self::__normalizeLabel($label);    
		if (($label===null)||($value===null)) return false;
		/*
		 * Controllo sulla safety dell'inserimento dell'item
		 * In caso contrario rischio di sovrascrivere arrayItems[$label] e/o duplicare _hash[$value]
		 * in modo che puntino alla stessa label. E viceversa.
		 * Dopo eseguo l'inserimento.
		 */
		if ((!array_key_exists($keyLabel, $this->_arrayItems)) && (!array_key_exists($value, $this->_hash))) {            
			$this->_arrayItems[$keyLabel]['id_option'] = $id;
			$this->_arrayItems[$keyLabel]['value'] = $value;
			$this->_arrayItems[$keyLabel]['label'] = $label;
			$this->_arrayItems[$keyLabel]['disabled'] = $disabled;
			$this->_arrayItems[$keyLabel]['readonly'] = $readonly;
			$this->_arrayItems[$keyLabel]['type'] = 'option';
			$this->_arrayItems[$keyLabel]['selected'] = ($settato) ? $settato : false;
			$this->_arrayItems[$keyLabel]['javascript'] = ($javascript) ? $javascript : '';
			$this->_hash[$value] = $keyLabel;
			return true;
		}
		return false;
	}
    
    protected function __normalizeLabel($label){
        $label = strtolower(str_replace(' ','_',$label));
        return $label;
    }

	public function addOptGroup ($label,$state='open'){
		$this->_arrayItems[$label.'_'.$state]['type'] = 'optgroup';
		$this->_arrayItems[$label.'_'.$state]['value'] = $state;
		$this->_arrayItems[$label.'_'.$state]['label'] = $label;
	}

	//Aggiunge una opzione se utilizzo l'oggetto OPTION
	public function addOption ($option){
		$data = $option->getData();
		$this->_arrayItems[$this->count]['id_option'] = $data['id_option'];
		$this->_arrayItems[$this->count]['value'] = $data['value'];
		$this->_arrayItems[$this->count]['label'] = $data['label'];
		$this->_arrayItems[$this->count]['type'] = $data['type'];
		$this->_arrayItems[$this->count]['selected'] = ($data['selected']) ? $settato : false;
		$this->_arrayItems[$this->count]['javascript'] = $data['javascript'];
		$this->_hash[$data['value']] = $this->_count;
		$this->_count++;
	}

	public function reset(){
		foreach ($this->_arrayItems as $label=>$item)
    		if ($item['type'] == 'option')
    		  $item['selected'] = false;
	}

	public function setSize($size){
		$this->_size=$size;
	}

	public function setWidth($width){
		$this->_width = $width;
	}

	public function setMultiple($bol){
		$this->_multiple = $bol;
		$this->_piece = ($bol) ? '[]' : '';
	}

	//Pu? capitare che due opzioni, che hanno LABEL diversi, abbiano lo stesso
	//valore. Se setto in base al valore, potrebbe capitare che la preselezione
	//selezioni una voce errata. Specific specifica il label preciso da selezionare
	//Valido sono in caso di SELECT non multiple
	public function setValue($given = null, $specific = null) {
	    
		 if (!is_array($given) && 
		  (($given === null) || strlen($given) == 0)) return;
    	if (!is_array($given))
		  $given = array ($given);
        //Before setting the checked selection, I have to deselected all the option
		  foreach ($this->_arrayItems as $label => &$value){
            $value['selected'] = false;          
        }   

        foreach ($given as $selectIndex){
        	 $myKey = $this->_hash[$selectIndex];
     
            if (is_null($specific)) {
                $this->_arrayItems[$myKey]['selected'] = true;
            }
            else
                $this->_arrayItems[$specific]['selected'] = true;
        }   
                 
	}

	public function isInside($label){
		if (array_key_exists($label,$this->_arrayItems)) return true;
		return false;
	}

	public function validate(){		
    if (parent::validate()) {
			$this->_valid = false;
			 
			if ( (!($this->_required)) || ($this->_disabled) )
			     $this->_valid = true;
			
			foreach ($this->_arrayItems as $label=>$item){
				  if (($item['type'] == 'option') && ($item['selected'])) 
			       $this->_valid = true;
			}
			       
		}      
		else $this->_valid = $this->_forceValid;		  
		return $this->_valid;
	}

	public function getCode(){
		self::__buildBaseCode();
		
		
		$selectTemplate = '<select id="[[id]]" size="[[size]]" name="[[name]]'.$this->_piece.'" style="width:[[width]]px;" [[style]] [[readonly]] [[disabled]] [[multiple]] [[javascript]]>[[options]]</select>';
		$optionTemplate = '<option id="[[id]]" value="[[value]]" [[javascript]] [[selected]] [[readonly]] [[disabled]]>[[label]]</option>';
		$optGroupTemplate = '<optgroup label="[[label]]">[[goptions]]</optgroup>';

		$code = str_replace ('[[name]]',$this->_name,$selectTemplate);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
		$code = str_replace ('[[readonly]]',$ro,$code);
		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
		$code = str_replace ('[[disabled]]',$di,$code);
		$mu = ($this->_multiple) ? 'multiple = "multiple"' : '';
		$code = str_replace ('[[multiple]]',$mu,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[width]]',$this->_width,$code);
		$code = str_replace ('[[size]]',$this->_size,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);

		$optionsCode = '';
		$oCode = '';
		$totalCode = '';
		//print_r ($this->_arrayItems);
		foreach ($this->_arrayItems as $label=>$item){
			if (($label===null)||($item['value']===null)) continue; // In realt? dovremmo gi? essere sicuri di questo comportamento
			
			if (($item['type'] == 'optgroup') && ($item['value'] == 'open')) {
				$oCode = str_replace ('[[label]]',$item['label'],$optGroupTemplate);
			}
			if (($item['type'] == 'optgroup') && ($item['value'] == 'close')) {
				$oCode = str_replace ('[[goptions]]',$optionsCode,$oCode);
				$optionsCode = '';
				$totalCode .= $oCode;
			}
			if ($item['type'] == 'option') {				
				$fCode = str_replace ('[[value]]',html_entity_decode(stripslashes($item['value'])),$optionTemplate);
				$fCode = str_replace ('[[id]]',$item['id_option'],$fCode);
				$fCode = str_replace ('[[label]]',$item['label'],$fCode);
				$fCode = str_replace ('[[javascript]]',$item['javascript'],$fCode);
				$fCode = str_replace ('[[readonly]]',(is_null($item['readonly']) ? "":'readonly = "readonly"'),$fCode);
				$fCode = str_replace ('[[disabled]]',(is_null($item['disabled']) ? "":'disabled = "disabled"'),$fCode);
				$se = ($item['selected']) ? 'selected = "selected"' : '';
				$fCode = str_replace ('[[selected]]',$se,$fCode);
				$optionsCode .= $fCode;
			}
		}

		$code = str_replace ('[[options]]',$totalCode.$optionsCode,$code);
		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);
		return $this->_code;
	}
}

class option
{
	private $_id = null;
	private $_attributes = null;
	private $_data = null;

	function __construct ($label,$value,$settato=false,$id=null){
		if ($id) $this->_id = $id;
		$this->_data = array ('id_option'=>$this->_id,
								 'selected'=>false,
								 'value'=>$value,
								 'label'=>$label,
								 'type'=>'option',
								 'attributes'=>'');
	}

	public function setId($id){
		$this->_id = $id;
		$this->_data['id_option'] = $id;
	}

	public function setAttributes($attributes) {
		$this->_data['attributes'] = $attributes;
	}

	public function getData(){
		return $this->_data;
	}

}

class textarea extends input
{
	private $rows = null;
	private $cols = null;

	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->_type = 'textarea';
		$this->_rows = 4;
		$this->_cols = 30;
	}

	public function setCols ($cols){
		$this->_cols = $cols;
	}

	public function setRows ($rows){
		$this->_rows = $rows;
	}

	public function setValue($value){
		$this->_value = stripslashes($value);
	}

	public function validate(){
		if (parent::validate())
		if ( ($this->_disabled) || (!$this->_required) )
		  $this->_valid = true;
		elseif ( (($this->_required) && (strlen ($this->_value)>0)) )
		  $this->_valid = true;
		else
		  $this->_valid = false;
		return $this->_valid;
	}

	public function getCode(){
		self::__buildBaseCode();

		$templateCode = '<textarea id="[[id]]" cols="[[cols]]" rows="[[rows]]" name="[[name]]" [[disabled]] [[readonly]] [[javascript]] [[style]] >[[value]]</textarea>';

		$code = str_replace ('[[name]]',$this->_name,$templateCode);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
		$code = str_replace ('[[readonly]]',$ro,$code);
		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
		$code = str_replace ('[[disabled]]',$di,$code);
		$code = str_replace ('[[rows]]',$this->_rows,$code);
		$code = str_replace ('[[cols]]',$this->_cols,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);

		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);

		return $this->_code;

	}

}

class wysiwyg extends textarea
{
	private $_level = null;
	private $_iconPath = null;
	private $_previewPath = null;
	private $_finalPath = null;

	private $_imagePath = null;

	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->_id = 'nicEditor_'.$name;
		$this->_level = 1;
		$this->_iconPath = './template/common';
		$this->_previewPath = './';
		$this->_finalPath = './';
		$_imagePath = '';
	}

	public function setLevel($level){
		$this->_level = $level;
	}

	public function setIconPath($path){
		$this->_iconPath = $path;
	}

	public function setPath($path){
		$this->_imagePath = $path;
	}

	public function setPreviewPath($path){
		$this->_previewPath = $path;
	}

	public function setFinalPath($path){
		$this->_finalPath = $path;
	}

	public function getCode(){
		parent::getCode();

		switch ($this->_level){
			case 1: $cCode = "new nicEditor({buttonList : ['bold','italic','underline','strikeThrough','left','center','right'],iconsPath : '".$this->_iconPath."/nicEditorIcons.gif'}).panelInstance('".$this->_id."');";  break;
			case 3: $cCode = "new nicEditor({fullPanel : true, iconsPath : '".$this->_iconPath."/nicEditorIcons.gif'}).panelInstance('".$this->_id."');"; break;
			case 2:
			default: $cCode = "new nicEditor({
													buttonList: ['bold','italic','underline','forecolor','left','center','right','ol','ul','fontSize','fontFamily','fontFormat','indent','outdent','xhtml'],
													iconsPath : '".$this->_iconPath."/nicEditorIcons.gif'}).panelInstance('".$this->_id."');
												    ";  break;
		}

		//$cCode .= "new nicEditor({iconsPath : 'htmlForm_4.1/nicEditorIcons.gif'}).panelInstance('".$this->_id."');";

		$javascriptText = "<script type=\"text/javascript\">
									var imgPath = '".$this->_iconPath."';
									bkLib.onDomLoaded(function() {
									//new nicEditor().panelInstance('".$this->_id."');
									".$cCode."
								});

							   </script>";
		//$javascriptText = '';

		$hiddenCode = '<input type="hidden" name="'.$this->_name.'_editor_previewpath" value="'.$this->_previewPath.'" />
						   <input type="hidden" name="'.$this->_name.'_editor_finalpath" value="'.$this->_finalPath.'" />';

		return $javascriptText.$this->_code.$hiddenCode;
	}

}

class image extends input
{

	protected $_path = null;
	protected $_url  = null;
	protected $_thumb = null;
	protected $_previewWidth = 60;
	protected $_previewHeight = 60;

	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->_type= 'file';
		$this->_thumb = 'default.gif';
		$this->_value = 'default.gif';
	}

	public function setPreviewWidth($width){
		$this->_previewWidth = $width;
	}

	public function setPreviewHeight($height){
		$this->_previewHeight = $height;
	}

	public function setValue($image){
		$this->_value = $image;
		if ($this->_thumb == 'default.gif')
		$this->_thumb = $image;
	}

	public function setPath ($path){
		$this->_path = $path;
		$this->_url = kernel::path2Url($path);
	}

	public function setPreview($thumb){
		if (file_exists($this->_path.$thumb))
		$this->_thumb = $thumb;
	}

	protected function __buildBaseCode(){

		$template = '<div class="inputContainer">
							<div class="inputInfo" style="width:[[infowidth]]%;">
								<label>[[label]]</label>
							</div>
							<div class="inputContent" style="width:[[contentwidth]]%;">
								[[filechooser]]
								[[image]]
								[[delimage]]
								[[notecode]]
								[[specificcode]]
								[[errorcode]]
							</div>
						</div>
					';

		$templateNote = '<div class="inputNote">[[note]]</div>';
		$noteCode = str_replace ('[[note]]',$this->_note,$templateNote);

		$templateError = '<div class="inputError">Error: [[error]]</div>';
		$errorCode =  str_replace ('[[error]]',$this->_language['genError'],$templateError);

		if ($this->_required) $this->_label = $this->_label.' *';

		$this->_code = str_replace ('[[label]]',$this->_label,$template);

		$this->_code = str_replace ('[[infowidth]]',$this->_widthCols[0]-1,$this->_code);
		$this->_code = str_replace ('[[contentwidth]]',$this->_widthCols[1]-1,$this->_code);

		$replace = (!is_null($this->_note)) ? $noteCode : '';
		$this->_code = str_replace ('[[notecode]]',$replace,$this->_code);

		$replace = ((strlen($this->_language['genError'])>0) && ( (!$this->_valid) || (!$this->_forceValid)) )? $errorCode : '';
		$this->_code = str_replace ('[[errorcode]]',$replace,$this->_code);

		$templateSpecific = '<div class="inputSpecific">[[specific]]</div>';
		$replace = str_replace ('[[specific]]','',$templateSpecific);
		if ($this->_readonly) $replace = str_replace ('[[specific]]',$this->_language['readonly'],$templateSpecific);
		if ($this->_disabled) $replace = str_replace ('[[specific]]',$this->_language['disabled'],$templateSpecific);

		$this->_code = str_replace ('[[specificcode]]',$replace,$this->_code);
	}


	public function getCode(){
		self::__buildBaseCode();

		$imageInformation = array ('width'=>$this->_previewWidth,'height'=>$this->_previewHeight);
		//TO DO: Da testare come mai non va
		if (file_exists($this->_path.$this->_value)) {
			list($imageInformation['width'], $imageInformation['height']) = getimagesize ($this->_path.$this->_value);
		}

		$dimension = (($this->_previewWidth / $this->_previewHeight) >= ($imageInformation['width'] / $imageInformation['height'])) ? 'height="'.$this->_previewHeight.'"' : 'width="'.$this->_previewWidth.'"';
		//$dimension = 'width:60px; height:60px;';
		$imageCode = '<img style="margin:2px 5px 5px 0;float:left;border:1px solid black;cursor:pointer;" '.$dimension.'  src="'.$this->_url.$this->_thumb.'" alt="'.$this->_value.'" onClick="managerImagePreview(this,\''.$this->_url.$this->_value.'\',\''.$this->_previewWidth.'\',\''.$this->_previewHeight.'\')" />';
		$filechooserCode = '<div><input type="'.$this->_type.'" id="[[id]]" name="[[name]]" [[disabled]] [[readonly]] [[javascript]] [[style]] /></div>';
		$delimageCode = '<input type="checkbox" name="delimg[]" value="'.$this->_value.'" /><label>'.$this->_language['delete'].'</label>';

		$filechooserCode = str_replace ('[[name]]',$this->_name,$filechooserCode);
		$filechooserCode = str_replace ('[[id]]',$this->_id,$filechooserCode);
		$filechooserCode = str_replace ('[[readonly]]',(($this->_readonly) ? 'readonly = "readonly"' : ''),$filechooserCode);
		$filechooserCode = str_replace ('[[disabled]]',(($this->_disabled) ? 'disabled = "disabled"' : ''),$filechooserCode);
		$filechooserCode = str_replace ('[[style]]',$this->_style,$filechooserCode);
		$filechooserCode = str_replace ('[[javascript]]',$this->_javascript,$filechooserCode);

		$this->_code = str_replace ('[[filechooser]]',$filechooserCode,$this->_code);
		$this->_code = str_replace ('[[image]]',$imageCode,$this->_code);
		$this->_code = str_replace ('[[delimage]]',$delimageCode,$this->_code);

		return $this->_code;
	}

}

class calendar extends input
{

	var $_width = null;
	var $_height = null;
	var $_javascriptCode = null;
	var $_format = null;
	var $_javascriptPath = null;
	var $_lang = null;

	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		global $lang;
		$this->_width = 300;
		$this->_height = 250;
		$this->_type = 'calendar';
		$this->_size = 15;
		$this->_format = 'yyyy/mm/dd';
		$this->_pathImage = './modules/inetd/libs/calendarImages/';
		$this->_id = $this->_name;
		$this->_javascriptPath = './template/common/';
		$this->_lang = $lang;
	}

	public function validate(){
		if ($this->_disabled)
		$this->_valid = true;
		elseif (!$this->_required)
		$this->valid = true;
		elseif ( (($this->_required) && (strlen ($this->_value)>0)) )
		$this->_valid = true;
		else
		$this->_valid = false;

		return $this->_valid;
	}

	public function setSize($size){
		$this->_size = $size;
	}

	public function setFormat($format){
		$this->_format = str_replace ('g','d',$format);
	}

	public function setLanguage ($lang){
		$this->_lang = $lang;
	}

	private function __buildJavascriptComponent(){
		$this->_javascriptCode = '<script>
									   var height = "'.$this->_height.'";
									   var width = "'.$this->_width.'";
									   var languageCode = "'.$this->_lang.'";
									   var heading = "#ffaaff";
									   var bgcolor1 = "#ffdddd";
									   var bgcolor2 = "#eeffcc";
								  	   var font1 = "blue";
									   var font2 = "#000000";
									   var pathToImages = "'.$this->_pathImage.'";
									</script>';
		//<script type="text/javascript" src="'.$this->_javascriptPath.'/calendar.js"></script>';
	}

	public function getCode(){
		self::__buildBaseCode();
		self::__buildJavascriptComponent();

		$templateCode = '<input type="text" id="[[id]]" name="[[name]]" value="[[value]]" [[disabled]] [[readonly]] [[javascript]] [[style]] > <input type="button" value="'.$this->_language['calendar']['button'].'"  onclick="displayCalendar(document.getElementById(\''.$this->_id.'\'),\''.strtolower($this->_format).'\',this)">';

		$code = str_replace ('[[name]]',$this->_name,$templateCode);
		$code = str_replace ('[[id]]',$this->_id,$code);
		$ro = ($this->_readonly) ? 'readonly = "readonly"' : '';
		$code = str_replace ('[[readonly]]',$ro,$code);
		$di = ($this->_disabled) ? 'disabled = "disabled"' : '';
		$code = str_replace ('[[disabled]]',$di,$code);
		$code = str_replace ('[[style]]',$this->_style,$code);
		$code = str_replace ('[[javascript]]',$this->_javascript,$code);
		$code = str_replace ('[[value]]',$this->_value,$code);

		$this->_code = str_replace ('[[inputcode]]',$code,$this->_code);

		return $this->_javascriptCode.$this->_code;

	}

}

class custom extends input
{
	private $_content = null;

	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->type = 'custom';
		$this->_content = '';
	}

	public function validate(){
	 $this->_valid = true;
	  if (!$this->_forceValid) {
            $this->_valid = false;
      }       
      return $this->_valid ;
	}

	public function setContent($content){
		$this->_content = $content;
	}

	private function __build(){
		//self::__buildBaseCode();
		$template = '<div class="inputContainer">
							<div class="inputContent" style="width:100%;[[style]]" id="[[id]]" [[javascript]]>
								[[content]]<br />
								<span style="color:#990000;">[[errorcode]]</span>
							</div>
						</div>';
		$template = str_replace ('[[id]]',$this->_id,$template);
		$template = str_replace ('[[style]]',$this->_style,$template);
		$template = str_replace ('[[javascript]]',$this->_javascript,$template);
		$replace = (!$this->_forceValid) ? $this->_error : '';
		$template = str_replace ('[[errorcode]]',$replace,$template);
		
		$this->_code = str_replace ('[[content]]',$this->_content,$template);
	}

	public function getCode(){
		self::__build();
		return $this->_code;
	}

}

class months extends select
{
	function __construct ($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		foreach ($this->_language['calendar']['month'] as $value=>$label)
		self::addItem($label,$value+1);
	}

	public function validate(){
		$this->valid = true;
	}

	public function build(){
		self::__buildBaseCode();
		$this->_code = $this->content;
		return $this->_code;
	}
}

/************************* FILE BROWSER NON COMPLETO *******************************/
class fileBrowser extends input
{
	private $_path			= null;
	private $_url			= null;
	private $_ajaxPath		= null;
	private $_widthResize 	= null;
	private $_heightResize 	= null;

	function __construct($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->_type = 'text';
		$this->_ajaxPath = kernel::bRoot().'/library/htmlformAjax.php';
		$this->_widthResize = 0;
		$this->__heightResize = 0;
	}

	public function validate(){
		$this->valid = true;
	}

	public function setResizeDimension($x,$y){
		$this->_widthResize = $x;
		$this->_heightResize = $y;
	}

	public function setPath($path){
		$this->_path = $path;
		$this->_url = kernel::path2Url($path);
	}

	public function setAjaxPath($aPath){
		$this->_ajaxPath = $aPath;
	}


	private function __build(){
		self::__buildBaseCode();
		$template = '<div class="inputContainer">
							<input id="'.$this->_name.'_currentDir" type="hidden" name="'.$this->_name.'_currentDir" value="" />
							<div id="'.$this->_name.'_listfile" class="listFileContainer" >
								&nbsp;
							</div>
							<div class="previewFileContainer" id="previewFileContainer">
								&nbsp;
							</div>
							<label>'.$this->_language['selectedFile'].'</label>: <input id="'.$this->_name.'_selectedFile" type="text" size="30" name="'.$this->_name.'_selectedFile" value=""/>
							<label>Carica un file</label>  <input type="button" value="Carica" onClick="window.open(\''.kernel::bRoot().'/library/h4upload.php?name='.$this->_name.'\',\'Upload Manager\',\'width=400,height=300 ,toolbar=no,location=no,status=no,menubar=no,scrollbars=no,resizable=no\');" />
						</div>
						<script>
							var defaultWidthResize = '.$this->_widthResize.';
							var defaultHeightResize = '.$this->_heightResize.';
							var siteRoot = "'.kernel::bRoot().'";
							var modUrl   = "'.substr ($this->_url,0,strpos($this->_url,'/sharedata')).'sharedata";
							var ajaxPath = "'.$this->_ajaxPath.'";
							var currPath = "'.$this->_path.'";
							var prevPath = "'.$this->_path.'";
							retrieveFileList(ajaxPath,\''.$this->_path.'\',\''.$this->_name.'\');
						</script>';

		$this->_code = $rowTemplate.str_replace ('[[inputcode]]',$template,$this->_code);
	}

	public function getCode(){
		self::__build();
		return $this->_code;
	}

}


/************************* FILE CHOOSER *******************************/
class fileChooser extends input
{
	private $_path			= null;
	private $_url			= null;
	private $_widthResize 	= null;
	private $_heightResize 	= null;

	function __construct($name,$value=NULL,$label=NULL,$class=NULL,$id=NULL,$style=NULL, $attributes=NULL, $error=NULL, $note=NULL){
		parent::__construct ($name,$value,$class,$label,$id,$value,$style,$attributes,$error,$note);
		$this->_type = 'text';
		$this->_widthResize = 100;
		$this->_heightResize = 100;
	}


	public function setResizeDimension($x,$y){
		$this->_widthResize = $x;
		$this->_heightResize = $y;
	}

	public function setPath($path){
		$this->_path = $path;
		$this->_url = kernel::path2Url($path);
	}

	public function setAjaxPath($aPath){
		$this->_ajaxPath = $aPath;
	}


	private function __build(){
		self::__buildBaseCode();
		$template = '<div class="inputContainer">
							<input id="'.$this->_name.'_currentDir" type="hidden" name="'.$this->_name.'_currentDir" value="" />
							<input id="'.$this->_name.'_selectedFile" type="text" size="30" name="'.$this->_name.'_selectedFile" value=""/>
							<input type="button" value="Choose" onClick="window.open(\''.kernel::bRoot().'/library/htmlFormFiles/h4FileBrowser.php?path='.$this->_path.'&name='.$this->_name.'\',\'Upload Manager\',\'width=500,height=330 ,address=no,toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes\');" />
						</div>
						<script>
							var defaultWidthResize = '.$this->_widthResize.';
							var defaultHeightResize = '.$this->_heightResize.';
							var siteRoot = "'.kernel::bRoot().'";
							var modUrl   = "'.substr ($this->_url,0,strpos($this->_url,'/sharedata')).'sharedata";
							var currPath = "'.$this->_path.'";
							var basePath = "'.$this->_path.'";
						</script>';

		$this->_code = str_replace ('[[inputcode]]',$template,$this->_code);
	}

	public function getCode(){
		parent::__build();
		return $this->_code;
	}

}


class classicdatelight extends input
{
    protected $_month = null;
    protected $_year = null;
    protected $_calendar = null;
    
        function __construct($name){
        parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
        $this->_type = 'text';      
        $this->_valid = true;   
        $this->_value = array ('month'=>'','year'=>'');                     
        $this->_arrayNote['error'] = 'Data non Corretta';       
    }
    
    public function setValid($val){
        $this->_valid = $val;
    }       
    
    public function setValue($value){
        
        if (is_array($value)){
            $this->_value['month'] = $value['month'];
            $this->_value['year'] = $value['year'];   
        }
        else {
            $v = explode ('-',$value);
            $this->_value['month'] = $v[1];
            $this->_value['year'] = $v[0];       
        }
                  
    }
        
    public function validate(){     
    	if ($this->_readonly) {
            $this->_valid = true;
            return true;
        }
        if (!$this->_forceValid) {
            $this->_valid = false;
            return false;       
        }       
        if ($this->_forceValid > 0) return true;
        if (($this->_required)){
            foreach ($this->_value as $value)
                if ($value == '')
                    $this->_valid = false;          
            if ($this->_valid)              
                if (!checkdate($this->_value['month'],1,'20'.$this->_value['year'])){
                    $this->_error = $this->_language['datanonvalida'];
                    $this->_valid = false;
                }           
                    
        }                       
        return $this->_valid;
    }       
    
    public function getCode(){     
        parent::__buildBaseCode();
                
        $templateCode = '<input type="text" size="3" value="[[month]]" name="[[name]][month]" maxlength="2"/> <input maxlength="2" type="text" size="3" value="[[year]]" name="[[name]][year]" />';
                                 
        $code = str_replace ('[[month]]',$this->_value['month'],$templateCode);
        $code = str_replace ('[[year]]',$this->_value['year'],$code);
        $code = str_replace ('[[name]]',$this->_name,$code);                
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
       
}


class classicdate extends classicdatelight
{
    protected $_day = null;
    
       function __construct($name){
        parent::__construct($name, $value=NULL, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
        $this->_type = 'text';      
        $this->_valid = true;   
        $this->_value = array ('day'=>'','month'=>'','year'=>'');                     
        $this->_arrayNote['error'] = 'Data non Corretta';       
    }
    
    public function setValid($val){
        $this->_valid = $val;
    }       
    
    public function setValue($value){
        
        if (is_array($value)){
            $this->_value['day'] = $value['day'];
            $this->_value['month'] = $value['month'];
            $this->_value['year'] = $value['year'];   
        }
        else {
            $v = explode ('-',$value);
            $this->_value['day'] = $v[2];
            $this->_value['month'] = $v[1];
            $this->_value['year'] = $v[0];       
        }
                  
    }
        
    public function validate(){                
        if ($this->_readonly) {
            $this->_valid = true;
            return true;
        }        
        if (!$this->_forceValid) {
            $this->_valid = false;
            return false;       
        }
        if ($this->_forceValid > 0) {
        	$this->_valid = true;
        	return true;       
        }
        if (($this->_required)){
            foreach ($this->_value as $value)
                if ($value == '')
                    $this->_valid = false;          
            if ($this->_valid)              
	            if (!checkdate($this->_value['month'],$this->_value['day'],$this->_value['year']) || ($this->_value['year'] < 1800)){
                    $this->_error = $this->_language['datanonvalida'];
                    $this->_valid = false;
                }           
                    
        }                       
        return $this->_valid;
    }       
    
    public function getCode(){     
        parent::__buildBaseCode();
                
        $templateCode = '<input type="text" size="3" value="[[day]]" name="[[name]][day]" /> <input type="text" size="3" value="[[month]]" name="[[name]][month]" /> <input type="text" size="5" value="[[year]]" name="[[name]][year]" />';
                         
        $code = str_replace ('[[day]]',$this->_value['day'],$templateCode);
        $code = str_replace ('[[month]]',$this->_value['month'],$code);
        $code = str_replace ('[[year]]',$this->_value['year'],$code);
        $code = str_replace ('[[name]]',$this->_name,$code);                
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
       
}

class sex extends input
{
    protected $_value = null;
    
    function __construct($name){
        parent::__construct($name, $value='f', $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL);
        $this->_type = 'radio';     
        $this->_valid = true;       
        $this->_value = '1';        
    }
    
    public function setValid($val=null){
        $this->_valid = $val;
    }       
    
    public function setValue($value){
        $this->_value = $value;
    }
        
    public function validate(){   
        parent::validate();             
        return $this->_valid;
    }       
    
    public function getCode(){     
        parent::__buildBaseCode();
                
        $templateCode = '<input type="radio" value="1" name="[[name]]" '.(($this->_value == '1' || is_null($this->_value)) ? 'checked="checked"' : '').'/> M <input type="radio" value="0" name="[[name]]" '.(($this->_value == '0') ? 'checked="checked"' : '').'/> F';
        $code = str_replace ('[[name]]',$this->_name,$templateCode);                
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
    
    
}

class cf extends text
{
    
    function __construct($name){
        parent::__construct($name, $value='f', $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';
        $this->_size = 30;
        $this->_valid = true;
    }   
    
    public function setValid($val){
        $this->_valid = $val;
    }
    
    public function validate(){                
        $this->_valid = true;
        if ($this->_readonly) {
            $this->_valid = true;
            return true;
        }
        if (!$this->_forceValid) {
            $this->_valid = false;
            return false;       
        }       
        if (($this->_required) && strlen($this->_value) == 0){
            $this->_valid = false;          
        }                       
        
        if ($this->_value != ''){           
            if (!preg_match ('/[A-Za-z]{6}[0-9]{2}[A-Za-z]{1}[0-9]{2}[A-Za-z]{1}[0-9]{3}[A-Za-z]{1}/',$this->_value,$found)) {
                $this->_error = $this->_language['cfnonvalido'];
                $this->_valid = false;
            }            
        }
        
        return $this->_valid;
    }
    
}

class money extends text
{        
    private $_moneyLabel = null;
    
    function __construct($name){
        parent::__construct($name, $value=null, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';  
        $this->_moneyLabel = 'euro';      
        $this->_valid = true;
        $this->_value = array('unit'=>'','decimal'=>'00');
    }   
 
    public function setMoneyLabel($l){
         $this->_moneyLabel = $l;
    }                
 
    public function validate(){
        parent::validate(); 
        if ( ($this->_required) && ( ($this->_value['unit'] == '') || ($this->_value['decimal'] == '') ) )
            $this->_valid = false;                        
        else                       
            if (preg_match ('/[A-Za-z]+/',$this->_value['unit'],$found) || preg_match ('/[A-Za-z]+/',$this->_value['decimal'],$found)) {                                
                $this->_error = 'Valuta non valida o non completa';
                $this->_valid = false;
            }
            else {
                $this->_valid = true;                
            }          
              
        return $this->_valid;
    }
    
    public function setValue($value){
        if (!is_array($value)){
            $t = explode (",",$value);
            $this->_value['decimal'] = $t[1];
            $this->_value['unit'] = $t[0];              
        }       
        else {
            $this->_value['decimal'] = $value['decimal'];
            $this->_value['unit'] = $value['unit'];   
        }         
    }
    
        
     public function getCode(){     
        parent::__buildBaseCode();
                                
        $templateCode = '<input type="text" size="30" name="[[name]][unit]" value="[[valueunit]]" style="text-align:right;"/> , <input type="text" size="3" name="[[name]][decimal]" value="[[valuedecimal]]" /> [[moneylabel]]';
        $code = str_replace ('[[name]]',$this->_name,$templateCode);                
        $code = str_replace ('[[moneylabel]]',$this->_moneyLabel,$code);
        $code = str_replace ('[[valueunit]]',$this->_value['unit'],$code);
        $code = str_replace ('[[valuedecimal]]',$this->_value['decimal'],$code);
        
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
    
}

class piva extends text
{
    
    function __construct($name){
        parent::__construct($name, $value=null, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';
        $this->_size = 30;
        $this->_valid = true;
    }
       
   function validate(){
        parent::validate();                       
        
        if ($this->_value != ''){                       
            if (!preg_match ('/[0-9]{11}/',$this->_value,$found)) {
                $this->_arrayNote['error'] = 'Partita IVA non Valida';
                $this->_valid = false;
            }            
        }
        
        return $this->_valid;
    }
    
}

class swift extends text
{
	
	function __construct($name){
        parent::__construct($name, $value=null, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';
        $this->_size = 15;
        $this->_valid = true;        
    }
    
 	public function setValue($value){
        $this->_value = $value;
    }   
    
    public function validate(){
        parent::validate();

        if (trim($this->_value) == "") {
        	$this->_valid = true;
        }
        elseif ( (!preg_match ('/([0-9A-Za-z]{11}|[0-9A-Za-z]{8})/',trim($this->_value))) || ( (strlen(trim($this->_value))!=11) && (strlen(trim($this->_value))!=8))   ) {
        	$this->_valid = false;
        	$this->_error .= $this->_language['swiftcodenonvalido'];
        }
        
        return $this->_valid;
    }
	
}

class iban extends text
{
    
    function __construct($name){
    	global $locale;
        parent::__construct($name, $value=null, $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';
        $this->_size = 30;
        $this->_valid = true;
        $this->_value = array ('','','','');
        $this->_note = $this->_language['ibanexample']; 
    }
     
    public function setValue($value){
        $this->_value = $value;
    }   
    
    public function validate(){
        parent::validate();                       
        
        if ( (!preg_match ('/[A-Za-z]{2}[0-9]{2}[A-Za-z]{1}/',$this->_value[0])) || (strlen($this->_value[0])>5) ) {
        	$this->_valid = false;
        	$this->_error .= $this->_language['ibanerror1'];
        }
    	
        if ( (!preg_match ('/[0-9]{5}/',$this->_value[1])) || (strlen($this->_value[1])>5) )  {
        	$this->_valid = false;
        	$this->_error .= $this->_language['ibanerror2'];
        }
        
        if ( (!preg_match ('/[0-9]{5}/',$this->_value[2])) || (strlen($this->_value[2])>5) ) {
        	$this->_valid = false;
        	$this->_error .= $this->_language['ibanerror3'];
        }
        
    	if ( (!preg_match ('/[0-9A-Za-z]{12}/',$this->_value[3])) || (strlen($this->_value[3])>12)  ) {
        	$this->_valid = false;
        	$this->_error .= $this->_language['ibanerror4'];
        }
        
        return $this->_valid;
    }
            
 	public function getCode(){     
        parent::__buildBaseCode();
                
        $templateCode = '<input type="text" size="6" name="[[name]][0]" value="[[0]]" maxlength="5"/>
				         <input type="text" size="6" name="[[name]][1]" value="[[1]]" maxlength="5"/>
				         <input type="text" size="6" name="[[name]][2]" value="[[2]]" maxlength="5"/>
				         <input type="text" size="15" name="[[name]][3]" value="[[3]]" maxlength="12"/>';
        $code = str_replace ('[[name]]',$this->_name,$templateCode);
        
        
        foreach ($this->_value as $k=>$value)
        	$code = str_replace ('[['.$k.']]',$value,$code);                
        
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
    
}

class authority extends input
{
	private $_autorities = null;
    
    function __construct($name){
        parent::__construct($name, $value='f', $label=NULL, $id=NULL, $style=NULL, $javascript=NULL, $error=NULL, $note=NULL); 
        $this->_type = 'text';      
        $this->_valid = true;
        $this->_value = array ('type'=>'','value'=>'');
    }
    public function setValid($val){
        $this->_valid = $val;
    }
    
    public function setAutorities($auth){
    	$this->_autorities = $auth;
    }
    
   public function validate(){
        parent::validate();
        if (empty($this->_value['value']) && $this->_required)  {   
            $this->_valid = false;
            return false;
        }
        return $this->_valid;        
    }
    
    public function setValue($value){
    	$this->_value = $value;
    }
    
    function getCode(){
    	global $inetd, $locale;     
        parent::__buildBaseCode();
                
        $templateCode = '<select name="[[name]][type]">
        						[[options]]
                         </select> 
                         <input type="text" size="30" value="'.stripslashes($this->_value['value']).'" name="[[name]][value]" />';
		
        $options = '';
        foreach ($this->_autorities as $idType=>$auto_info){
        		if ($locale == $inetd["locale"][1]) {
		    		switch ($auto_info['owner_identification_document_releaser_fullname']) {
		    			case "Comune di":
		    				$auto_info['owner_identification_document_releaser_fullname'] = "Municipality of";
		    				break;
		    			case 'Questura di':
		    				$auto_info['owner_identification_document_releaser_fullname'] = "Questor of";
		    				break;
		    			case 'Prefetto di':
		    				$auto_info['owner_identification_document_releaser_fullname'] = "Prefect of";
		    				break;
		    		}
		    	}
        	
        	$options .= '<option value="'.$idType.'"   '.(($this->_value['type'] == $idType) ? 'selected="selected"' : '').'>'.$auto_info['owner_identification_document_releaser_fullname'].'</option>';	
        }
        
        $code = str_replace ('[[name]]',$this->_name,$templateCode);        
        $code = str_replace ('[[options]]',$options,$code);
                
        return str_replace ('[[inputcode]]',$code,$this->_code);
    }
    
}

class contries extends select
{
    protected $_countries = null;
    
    function __construct($name){
        parent::__construct($name);
        self::__initialize();
    }   
    
    private function __initialize(){
        $this->_countries = Array ('Italia' => 'Italia',
                                    'Albania' => 'Albania',
                        
                                    'Argentina' => 'Argentina',
                                    'Armenia' => 'Armenia',
                                    'Australia' => 'Australia',
                                    'Austria' => 'Austria',
                                    'Azerbaijan' => 'Azerbaijan',
                                    'Belgium' => 'Belgium',
                        
                                    'Bosnia-Her' => 'Bosnia-Herzegowina',
                                    'Brazil' => 'Brazil',
                                    'Bulgaria' => 'Bulgaria',
                                    'Canada' => 'Canada',
                                    'China' => 'China',
                                    'Croatia' => 'Croatia',
                        
                                    'Cuba' => 'Cuba',
                                    'Cyprus' => 'Cyprus',
                                    'Czech Rep.' => 'Czech Republic',
                                    'Denmark' => 'Denmark',
                                    'Egypt' => 'Egypt',
                                    'Estonia' => 'Estonia',
                        
                                    'Finland' => 'Finland',
                                    'France' => 'France',
                                    'Georgia' => 'Georgia',
                                    'Germany' => 'Germany',
                                    'Greece' => 'Greece',
                                    'Hong Kong' => 'Hong Kong',
                        
                                    'Hungary' => 'Hungary',
                                    'Iceland' => 'Iceland',
                                    'India' => 'India',
                                    'Ireland' => 'Ireland',
                                    'Israel' => 'Israel',
                                    'Italia' => 'Italia',
                        
                                    'Japan' => 'Japan',
                                    'Kazakhstan' => 'Kazakhstan',
                                    'Latvia' => 'Latvia',
                                    'Liechtenst' => 'Liechtenstein',
                                    'Lithuania' => 'Lithuania',
                                    'Luxembourg' => 'Luxembourg',
                        
                                    'Macedonia' => 'Macedonia',
                                    'Malta' => 'Malta',
                                    'Mexico' => 'Mexico',
                                    'Moldova' => 'Moldova',
                                    'Monaco' => 'Monaco',
                                    'Netherland' => 'Netherlands',
                        
                                    'New Zealan' => 'New Zealand',
                                    'Norway' => 'Norway',
                                    'Poland' => 'Poland',
                                    'Portugal' => 'Portugal',
                                    'Romania' => 'Romania',
                                    'Russian F.' => 'Russian Federation',
                        
                                    'San Marino' => 'San Marino',
                                    'Saudi Arab' => 'Saudi Arabia',
                                    'Slovakia' => 'Slovakia',
                                    'Slovenia' => 'Slovenia',
                                    'South Afri' => 'South Africa',
                                    'Spain' => 'Spain',
                        
                                    'Sweden' => 'Sweden',
                                    'Switzerlan' => 'Switzerland',
                                    'Turkey' => 'Turkey',
                                    'Ukraine' => 'Ukraine',
                                    'United Ara' => 'United Arab Emirates',
                                    'United Kin' => 'United Kingdom',
                        
                                    'United Sta' => 'United States',
                                    'Uruguay' => 'Uruguay',
                                    'Uzbekistan' => 'Uzbekistan',
                                    'Vatican' => 'Vatican City State');
        
        foreach ($this->_countries as $label=>$value)
            self::addItem($label,$value);               
    }
    
    
}

class billingInformationCompany extends input 
{
	
	private $_billingInformationarray = array();
	
	function __construct($name){
        parent::__construct($name);
        $billingInformation = array('ks','pk','pr','ik','bd','ds','rz','au','ae');
        $billingLabels = array("Cost centre","Employee Number","Project Number","Internal Account","Departure date","Department","Destination","Order Number","Accounting Unit");
        $this->_billingInformationarray = array_combine($billingInformation,$billingLabels);
    }
    
    public function setVersion($version = 'suf'){
    	switch($version){
    		case 'flex': $billingInformation = array('ft','nm','ks','pk','pr','ik','bd','ds','rz','au','ae'); 
    					 $billingLabels = array("Purpose of the card","Payment Approver","Cost centre","Employee Number","Project Number","Internal Account","Departure date","Department","Destination","Order Number","Accounting Unit");
    					 break;
    		case 'suf':
    		case 'ppb':
    		case 'procurement':
    		default : $billingInformation = array('ks','pk','pr','ik','bd','ds','rz','au','ae');
    		$billingLabels = array("Cost centre","Employee Number","Project Number","Internal Account","Departure date","Department","Destination","Order Number","Accounting Unit");
    	}
    	
    	$this->_billingInformationarray = array_combine($billingInformation,$billingLabels);
    }
    
    protected function __buildLengthForm($name,$value = null){    	
    	$disabled = "";    	
    	if ($this->_value['online'][$name] > 0)
    		$disabled = 'disabled="disabled"';
    	$disabled = "";
    	//if ($value > 0 && !is_null($value) && (($name == 'ks_length') || ($name == 'ik_length') || ($name == 'pr_length') || ($name == 'pk_length')) )
    		    	
    	$code = '<select name="'.$this->_name.'[length]['.$name.']" '.$disabled.'>
    				[[options]]    	
    			 </select>';
    	
    	$optCode = '';
    	for ($h=0;$h<18;$h++)
    		$optCode .= '<option value="'.$h.'" '.(($value == $h) ? 'selected="selected"' : '').'>'.$h.'</option>';
    	
    	return str_replace('[[options]]',$optCode,$code);
    }
    
    protected function __buildYesNodForm($name,$value = null){
    	$disabled = "";
    	if ($this->_value['online'][$name] > 0)
    		$disabled = 'disabled="disabled"';
    	$disabled = "";
    	/*	 
    	if ($value > 0 && !is_null($value) &&  (($name == 'ks_required') || ($name == 'ik_required') || ($name == 'pr_required') || ($name == 'pk_required')) )
    		$disabled = 'disabled="disabled"';
    	*/
    	$selected = "";
    	if ($this->_value['required'][$name])
    		$selected = 'selected = "selected"';		
    		
    	return '<select name="'.$this->_name.'[required]['.$name.']" '.$disabled.'>
    				<option value="0">No</option>
    				<option value="1" '.$selected.'>S&igrave;</option>
    			</select>';    	
    }
    
    public function setValue($value){
    	$this->_value = $value;    	
    }
    
 	function getCode(){     
        parent::__buildBaseCode();
//         echo '<pre>';
//        print_r ($this->_billingInformationarray);
//         echo '</pre>';
        
        $hiddenInputCode = '';
        foreach ($this->_billingInformationarray as $key=>$value){
        	$hiddenInputCode .= '<input type="hidden" name="'.$this->_name.'[online]['.$key.'_length]" value="'.$this->_value['online'][''.$key.'_length'].'" />';
        	$hiddenInputCode .= '<input type="hidden" name="'.$this->_name.'[online]['.$key.'_required]" value="'.$this->_value['online'][''.$key.'_required'].'" />';
        }

//         $hiddenInputCode = '<input type="hidden" name="'.$this->_name.'[online][tf_length]" value="'.$this->_value['online']['tf_length'].'" />
//         					<input type="hidden" name="'.$this->_name.'[online][nm_length]" value="'.$this->_value['online']['nm_length'].'" />
//         					<input type="hidden" name="'.$this->_name.'[online][ks_length]" value="'.$this->_value['online']['ks_length'].'" />
//         					<input type="hidden" name="'.$this->_name.'[online][pk_length]" value="'.$this->_value['online']['pk_length'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][pr_length]" value="'.$this->_value['online']['pr_length'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][ik_length]" value="'.$this->_value['online']['ik_length'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][ks_required]" value="'.$this->_value['online']['ks_required'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][pk_required]" value="'.$this->_value['online']['pk_required'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][pr_required]" value="'.$this->_value['online']['pr_required'].'" />
// 					        <input type="hidden" name="'.$this->_name.'[online][ik_required]" value="'.$this->_value['online']['ik_required'].'" />';
        
        $templateCode = '<table border="0" cellspacing="1" cellpadding="1" style="border:1px solid black;">
        					<tr>
        						<th>ISIcms</th>
        						<th>Descrzione</th>
        						<th>Nome per Azienda</th>
        						<th>Attivo</th>
        						<th>Lunghezza</th>
        					</tr>
        				';
        
          foreach ($this->_billingInformationarray as $key=>$value){
          	 $templateCode.= '
          	 				<tr>
        						<td><b>'.strtoupper($key).'</b></td>
        						<td>'.$value.'</td>
        						<td><input type="text" size="35" name="'.$this->_name.'[society]['.$key.'_society_name]" value="'.$this->_value['society'][''.$key.'_society_name'].'" /></td>
        						<td>'.self::__buildYesNodForm(''.$key.'_required',$this->_value['required'][''.$key.'_required']).'</td>
        						<td>'.self::__buildLengthForm(''.$key.'_length',$this->_value['length'][''.$key.'_length']).'</td>
        					</tr>
          	 		';
          	
         	 } 
         	 
         	 $templateCode .= '</table>';
        
        
//         					<tr>
//         						<td><b>TF</b></td>
//         						<td>Cost Center</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][tf_society_name]" value="'.$this->_value['society']['tf_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('tf_required',$this->_value['required']['tf_required']).'</td>
//         						<td>'.self::__buildLengthForm('tf_length',$this->_value['length']['tf_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>NM</b></td>
//         						<td>Cost Center</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][nm_society_name]" value="'.$this->_value['society']['nm_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('nm_required',$this->_value['required']['nm_required']).'</td>
//         						<td>'.self::__buildLengthForm('nm_length',$this->_value['length']['nm_length']).'</td>
//         					</tr>
        		
        		
//         					<tr>
//         						<td><b>KS</b></td>
//         						<td>Cost Center</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][ks_society_name]" value="'.$this->_value['society']['ks_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('ks_required',$this->_value['required']['ks_required']).'</td>
//         						<td>'.self::__buildLengthForm('ks_length',$this->_value['length']['ks_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>PK</b></td>
//         						<td>Empl. Number</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][pk_society_name]"  value="'.$this->_value['society']['pk_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('pk_required',$this->_value['required']['pk_required']).'</td>
//         						<td>'.self::__buildLengthForm('pk_length',$this->_value['length']['pk_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>PR</b></td>
//         						<td>Project Number</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][pr_society_name]" value="'.$this->_value['society']['pr_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('pr_required',$this->_value['required']['pr_required']).'</td>
//         						<td>'.self::__buildLengthForm('pr_length',$this->_value['length']['pr_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>IK</b></td>
//         						<td>Internal Account</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][ik_society_name]" value="'.$this->_value['society']['ik_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('ik_required',$this->_value['required']['ik_required']).'</td>
//         						<td>'.self::__buildLengthForm('ik_length',$this->_value['length']['ik_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>BD</b></td>
//         						<td>Departure Date</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][bd_society_name]" value="'.$this->_value['society']['bd_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('bd_required',$this->_value['required']['bd_required']).'</td>
//         						<td>'.self::__buildLengthForm('bd_length',$this->_value['length']['bd_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>DS</b></td>
//         						<td>Deparment</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][ds_society_name]" value="'.$this->_value['society']['ds_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('ds_required',$this->_value['required']['ds_required']).'</td>
//         						<td>'.self::__buildLengthForm('ds_length',$this->_value['length']['ds_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>RZ</b></td>
//         						<td>Destination</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][rz_society_name]" value="'.$this->_value['society']['rz_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('rz_required',$this->_value['required']['rz_required']).'</td>
//         						<td>'.self::__buildLengthForm('rz_length',$this->_value['length']['rz_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>AU</b></td>
//         						<td>Order Number</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][au_society_name]" value="'.$this->_value['society']['au_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('au_required',$this->_value['required']['au_required']).'</td>
//         						<td>'.self::__buildLengthForm('au_length',$this->_value['length']['au_length']).'</td>
//         					</tr>
//         					<tr>
//         						<td><b>AE</b></td>
//         						<td>Accounting Unit</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][ae_society_name]" value="'.$this->_value['society']['ae_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('ae_required',$this->_value['required']['ae_required']).'</td>
//         						<td>'.self::__buildLengthForm('ae_length',$this->_value['length']['ae_length']).'</td>
//         					</tr>  
//         								<!-- 
//         					<tr>
//         						<td><b>AK</b></td>
//         						<td>Action Number</td>
//         						<td><input type="text" size="35" name="'.$this->_name.'[society][ak_society_name]" value="'.$this->_value['society']['ak_society_name'].'" /></td>
//         						<td>'.self::__buildYesNodForm('ak_required',$this->_value['required']['ak_required']).'</td>
//         						<td>'.self::__buildLengthForm('ak_length',$this->_value['length']['ak_length']).'</td>
//         					</tr>        	
//         								-->				
        			//	 </table>';		
        
        return $hiddenInputCode.$templateCode;
    }
}

class companyGreenDonation extends input{
	  protected $_inputText01 = null;
	  protected $_inputText02 = null;
	  protected $_inputText00 = null;
	   
    function __construct($name,$inputText1,$inputtext2,$inputtext0){
        parent::__construct($name);    
        $this->_inputText00 = $inputtext0;
        $this->_inputText01 = $inputText1;    
        $this->_inputText02 = $inputtext2;
    }
    
    function setValue($value){
    	if (is_array($value)){
    		$this->_value = $value;
    	}
    	else {
    		if ($value == 0){
    			$this->_value[2] = 0;
    		}
    		else {
    			$this->_value[0] = 50;
    			$this->_value[1] = $value;
    		}
    	}
    }
    
    function getCode(){     
        parent::__buildBaseCode();
        
        $check00 = false;
        $check01 = false;
        $check02 = false;
        if ($this->_value[1] == 50){
        	$check01 = true;
        }
        if ($this->_value[1] != null && $this->_value[1] != 50){
        	$check02 = true;
        }
        if ($this->_value[1] == null){
        	$check00 = true;
        }

        $this->_code = '<div class="inputNote">
	                        <ul style="list-style:none">
	                          <li><input type="radio" name="'.$this->_name.'_choice" value="2" '.(($check00)?"checked=\"checked\"":"").' /> '.$this->_inputText00.' <input type="text" name="'.$this->_name.'[2]" value="0" readonly="readonly" style="visibility:hidden;"/> </li>
	                          <li><input type="radio" name="'.$this->_name.'_choice" value="0" '.(($check01)?"checked=\"checked\"":"").' /> '.$this->_inputText01.' <input type="text" name="'.$this->_name.'[0]" value="50" readonly="readonly" size="2"/> euro</li>
	                          <li><input type="radio" name="'.$this->_name.'_choice" value="1" '.(($check02)?"checked=\"checked\"":"").'/> '.$this->_inputText02.' <input type="text" name="'.$this->_name.'[1]" value="'.(($this->_value[1]!=50)?$this->_value[1]:"").'"  size="6"/> euro </li>
	                        </ul>
                        </div>';
        
        return $this->_code;
    }
}

class companyServices extends input {
	
	  function __construct($name){
        parent::__construct($name);        
    }
    
 	public function setValue($value){
 		if (empty($value)){
 			$this->_value['required'] = array('bsp_required'=>true,'low_cost_required'=>true,'aida_required'=>true,
 					'hotel_required'=>true,'fs_required'=>true,'rent_car_required'=>true,'fees_required'=>true,'meeting_required'=>true);
 			return;
 		}
    	$this->_value = $value;    	
    }
    
 	protected function __buildYesNodForm($name, $value = null){
 		$selected = '';
 		if ($this->_value['required'][$name])
			$selected = 'selected = "selected"';
    	
		return '<select name="'.$this->_name.'[required]['.$name.']">
    				<option value="0">No</option>
    				<option value="1" '.$selected.'>S&igrave;</option>
    			</select>';    	
    }
    
	function getCode(){     
        parent::__buildBaseCode();
                
        $templateCode = '<table border="0" cellspacing="1" cellpadding="1" style="border:1px solid black;">
        					<tr>
        						<td><b>Biglietteria BSP</b></td>
        						<td>'.self::__buildYesNodForm('bsp_required').'</td>        						
        					</tr>
        					<tr>
        						<td><b>Biglietteria Low Cost</b></td>
        						<td>'.self::__buildYesNodForm('low_cost_required').'</td>
        					</tr>        				
        					<tr>
        						<td><b>Servizio A.I.D.A.</b></td>
        						<td>'.self::__buildYesNodForm('aida_required').'</td>
        					</tr>
        					<tr>
        						<td><b>Hotel</b></td>
        						<td>'.self::__buildYesNodForm('hotel_required').'</td>
        					</tr>
        					<tr>
        						<td><b>Biglietteria Ferroviaria</b></td>
        						<td>'.self::__buildYesNodForm('fs_required').'</td>
        					</tr>
        					<tr>
        						<td><b>Autonoleggi</b></td>
        						<td>'.self::__buildYesNodForm('rent_car_required').'</td>
        					</tr>
        					<tr>
        						<td><b>Transaction Fees</b></td>
        						<td>'.self::__buildYesNodForm('fees_required').'</td>
        					</tr>
        					<tr>
        						<td><b>Meeting e Congressi</b></td>
        						<td>'.self::__buildYesNodForm('meeting_required').'</td>
        					</tr>
        				 </table>';		               
        return str_replace('[[inputcode]]',$templateCode,$this->_code);
    }
}

class billingInformationTravel extends input 
{
	
	function __construct($name){
        parent::__construct($name);
        
    }
    
    protected function __buildLengthForm($name,$value = null){    	
    	$disabled = "";    	
    	if ($this->_value['online'][$name] > 0)
    		$disabled = 'disabled="disabled"';
    	$disabled = "";
    	//if ($value > 0 && !is_null($value) && (($name == 'ks_length') || ($name == 'ik_length') || ($name == 'pr_length') || ($name == 'pk_length')) )
    		    	
    	$code = '<select name="'.$this->_name.'[length]['.$name.']" '.$disabled.'>
    				[[options]]    	
    			 </select>';
    	
    	$optCode = '';
    	for ($h=0;$h<18;$h++)
    		$optCode .= '<option value="'.$h.'" '.(($value == $h) ? 'selected="selected"' : '').'>'.$h.'</option>';
    	
    	return str_replace('[[options]]',$optCode,$code);
    }
    
    protected function __buildYesNodForm($name,$value = null){
    	$disabled = "";
    	if ($this->_value['online'][$name] > 0)
    		$disabled = 'disabled="disabled"';
    	$disabled = "";
    	/*	 
    	if ($value > 0 && !is_null($value) &&  (($name == 'ks_required') || ($name == 'ik_required') || ($name == 'pr_required') || ($name == 'pk_required')) )
    		$disabled = 'disabled="disabled"';
    	*/
    	$selected = "";
    	if ($this->_value['required'][$name])
    		$selected = 'selected = "selected"';		
    		
    	return '<select name="'.$this->_name.'[required]['.$name.']" '.$disabled.'>
    				<option value="0">No</option>
    				<option value="1" '.$selected.'>S&igrave;</option>
    			</select>';    	
    }
    
    public function setValue($value){
    	$this->_value = $value;    	
    }
    
 	function getCode(){     
        parent::__buildBaseCode();
      //  print_r ($this->_value);

        $hiddenInputCode = '<input type="hidden" name="'.$this->_name.'[online][ks_length]" value="'.$this->_value['online']['ks_length'].'" />
        					<input type="hidden" name="'.$this->_name.'[online][pk_length]" value="'.$this->_value['online']['pk_length'].'" />
					        <input type="hidden" name="'.$this->_name.'[online][ik_length]" value="'.$this->_value['online']['ik_length'].'" />';
        
        $templateCode = '<table border="0" cellspacing="1" cellpadding="1" style="border:1px solid black;">
        					<tr>
        						<th>ISIcms</th>
        						<th>Descrzione</th>
        						<th>Nome per Azienda</th>
        						<th>Attivo</th>
        						<th>Lunghezza</th>
        					</tr>
        					<tr>
        						<td><b>KS</b></td>
        						<td>Cost Center</td>
        						<td><input type="text" size="35" name="'.$this->_name.'[society][ks_society_name]" value="'.$this->_value['society']['ks_society_name'].'" /></td>
        						<td>'.self::__buildYesNodForm('ks_required',$this->_value['required']['ks_required']).'</td>
        						<td>'.self::__buildLengthForm('ks_length',$this->_value['length']['ks_length']).'</td>
        					</tr>
        					<tr>
        						<td><b>PK</b></td>
        						<td>Empl. Number</td>
        						<td><input type="text" size="35" name="'.$this->_name.'[society][pk_society_name]"  value="'.$this->_value['society']['pk_society_name'].'" /></td>
        						<td>'.self::__buildYesNodForm('pk_required',$this->_value['required']['pk_required']).'</td>
        						<td>'.self::__buildLengthForm('pk_length',$this->_value['length']['pk_length']).'</td>
        					</tr>
        					<tr>
        						<td><b>IK</b></td>
        						<td>Internal Account</td>
        						<td><input type="text" size="35" name="'.$this->_name.'[society][ik_society_name]" value="'.$this->_value['society']['ik_society_name'].'" /></td>
        						<td>'.self::__buildYesNodForm('ik_required',$this->_value['required']['ik_required']).'</td>
        						<td>'.self::__buildLengthForm('ik_length',$this->_value['length']['ik_length']).'</td>
        					</tr>        				       					
        				 </table>';		
       	
                       
        
        return $hiddenInputCode.$templateCode;
    }
	
}


class referenceFieldsCrs extends input 
{
	
	function __construct($name){
        parent::__construct($name);
        
    }            
    
    public function setValue($value){
    	$this->_value = $value;    	
    }
    
	protected function __buildSubtotalForm($name,$value = null){				
    	return '<select name="'.$this->_name.'[subtotal]['.$name.']" '.$disabled.'>    				
    				<option value="No" '.(($value=='No') ? 'selected="selected"':'').' >No</option>
    				<option value="Within Invoice" '.(($value=='Within Invoice')? 'selected="selected"':'').'>Within Invoice</option>
    				<option value="on Summary" '.(($value=='on Summary')? 'selected="selected"':'').'>on Summary</option>
    				<option value="Inv+Summary" '.(($value=='Inv+Summary')? 'selected="selected"':'').'>Inv+Summary</option>    				
    			</select>';    	
    }
    
    protected function __buildOneToseventeenForm($name,$value=null){
    	$selectCode = '<select name="'.$this->_name.'['.$name.']">    	
    					 <option value="-">-</option>				  
    				   	 [[options]]
    				   </select>';
    	$optCode = "";
    	for ($i=1;$i<=17;$i++){
    		$selected = "";
    		if ($i==$value)
    			$selected = 'selected = "selected"';	
    		$optCode .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    	}
    	
    	return str_replace ('[[options]]',$optCode,$selectCode);
    }
    
    protected function __buildZeroToNineForm($name,$value=null){
    	
    	$selectCode = '<select name="'.$this->_name.'['.$name.']">
    					  <option value="-">-</option>
    				   	 [[options]]
    				   </select>';
    	$optCode = "";
    	for ($i=1;$i<=9;$i++){
    		$selected = "";
    		if ($i==$value)
    			$selected = 'selected = "selected"';	
    		$optCode .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    	}
    	
    	return str_replace ('[[options]]',$optCode,$selectCode);
    	
    }
    
	protected function __buildMandatorySelect($name,$value = null){
		return '<select name="'.$this->_name.'[mandatory]['.$name.']">
    				<option value="-" '.(($this->_value['mandatory'][$name] == '-') ? 'selected="selected"' : '').'>Mandatory</option>
    				<option value="1" '.(($this->_value['mandatory'][$name] == '1') ? 'selected="selected"' : '').'>several DBI are optional</option>
    				<option value="Y" '.(($this->_value['mandatory'][$name] == 'Y') ? 'selected="selected"' : '').'>DBI is only filled partially</option>
    			</select>';    	
    }
    
 	function getCode(){     
        parent::__buildBaseCode();
        $templateCode = '<table border="0" cellspacing="1" cellpadding="1" style="border:1px solid black;">
        					<tr>
        						<th>ISIcms</th>
        						<th>Renaming</th>
        						<th>Digits</th>
        						<th>Seq.</th>
        						<th>Sorting</th>
        						<th>M/O</th>
        						<th>Subtotal</th>
        					</tr>
        					<tr>
        						<td><b>KS</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ks_renaming]" value="'.$this->_value['ks_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ks_digits',$this->_value['ks_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('ks_sequence',$this->_value['ks_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ks_sorting',$this->_value['ks_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('ks').'</td>
        						<td>'.self::__buildSubtotalForm('ks',$this->_value['subtotal']['ks']).'</td>
        					</tr>
        					<tr>
        						<td><b>PK</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[pk_renaming]" value="'.$this->_value['pk_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('pk_digits',$this->_value['pk_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('pk_sequence',$this->_value['pk_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('pk_sorting',$this->_value['pk_sorting']).'</td>        						
        						<td>'.self::__buildMandatorySelect('pk').'</td>
        						<td>'.self::__buildSubtotalForm('pk',$this->_value['subtotal']['pk']).'</td>
        					</tr>
        					<tr>
        						<td><b>PR</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[pr_renaming]" value="'.$this->_value['pr_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('pr_digits',$this->_value['pr_digits']).'</td>      
        						<td>'.self::__buildZeroToNineForm('pr_sequence',$this->_value['pr_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('pr_sorting',$this->_value['pr_sorting']).'</td>  						
        						<td>'.self::__buildMandatorySelect('pr').'</td>
        						<td>'.self::__buildSubtotalForm('pr',$this->_value['subtotal']['pr']).'</td>
        					</tr>
        					<tr>
        						<td><b>DS</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ds_renaming]" value="'.$this->_value['ds_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ds_digits',$this->_value['ds_digits']).'</td>  
        						<td>'.self::__buildZeroToNineForm('ds_sequence',$this->_value['ds_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ds_sorting',$this->_value['ds_sorting']).'</td>      						
        						<td>'.self::__buildMandatorySelect('ds').'</td>
        						<td>'.self::__buildSubtotalForm('ds',$this->_value['subtotal']['ds']).'</td>
        					</tr>
        					<tr>
        						<td><b>AU</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[au_renaming]" value="'.$this->_value['au_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('au_digits',$this->_value['au_digits']).'</td>        
        						<td>'.self::__buildZeroToNineForm('au_sequence',$this->_value['au_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('au_sorting',$this->_value['au_sorting']).'</td>						
        						<td>'.self::__buildMandatorySelect('au').'</td>
        						<td>'.self::__buildSubtotalForm('au',$this->_value['subtotal']['au']).'</td>
        					</tr>
        					<tr>
        						<td><b>AE</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ae_renaming]" value="'.$this->_value['ae_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ae_digits',$this->_value['ae_digits']).'</td>        
        						<td>'.self::__buildZeroToNineForm('ae_sequence',$this->_value['ae_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ae_sorting',$this->_value['ae_sorting']).'</td>						
        						<td>'.self::__buildMandatorySelect('ae').'</td>
        						<td>'.self::__buildSubtotalForm('ae',$this->_value['subtotal']['ae']).'</td>
        					</tr>
        					<tr>
        						<td><b>BD</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[bd_renaming]" value="'.$this->_value['bd_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('bd_digits',$this->_value['bd_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('bd_sequence',$this->_value['bd_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('bd_sorting',$this->_value['bd_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('bd').'</td>
        						<td>'.self::__buildSubtotalForm('bd',$this->_value['subtotal']['bd']).'</td>
        					</tr>
        					<tr>
        						<td><b>IK</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ik_renaming]" value="'.$this->_value['ik_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ik_digits',$this->_value['ik_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('ik_sequence',$this->_value['ik_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ik_sorting',$this->_value['ik_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('ik').'</td>
        						<td>'.self::__buildSubtotalForm('ik',$this->_value['subtotal']['ik']).'</td>
        					</tr>
        					<tr>
        						<td><b>RZ</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[rz_renaming]" value="'.$this->_value['rz_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('rz_digits',$this->_value['rz_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('rz_sequence',$this->_value['rz_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('rz_sorting',$this->_value['rz_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('rz').'</td>
        						<td>'.self::__buildSubtotalForm('rz',$this->_value['subtotal']['rz']).'</td>
        					</tr>
        					<tr>
        						<td><b>AK</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ak_renaming]" value="'.$this->_value['ak_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ak_digits',$this->_value['ak_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('ak_sequence',$this->_value['ak_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ak_sorting',$this->_value['ak_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('ak').'</td>
        						<td>'.self::__buildSubtotalForm('ak',$this->_value['subtotal']['ak']).'</td>
        					</tr>
        					<tr>
        						<td><b>KR</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[kr_renaming]" value="'.$this->_value['kr_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('kr_digits',$this->_value['kr_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('kr_sequence',$this->_value['kr_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('kr_sorting',$this->_value['kr_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('kr').'</td>
        						<td>'.self::__buildSubtotalForm('kr',$this->_value['subtotal']['kr']).'</td>
        					</tr>
        				 </table>';		
       	
                       
        
        return $templateCode;
    }
	
}

class referenceFieldsTamara extends input 
{
	
	function __construct($name){
        parent::__construct($name);
        
    }            
    
    public function setValue($value){
    	$this->_value = $value;    	
    }
    
	protected function __buildSubtotalForm($name,$value = null){				
    	return '<select name="'.$this->_name.'[subtotal]['.$name.']" '.$disabled.'>    				
    				<option value="No" '.(($value=='No') ? 'selected="selected"':'').' >No</option>
    				<option value="Within Invoice" '.(($value=='Within Invoice')? 'selected="selected"':'').'>Within Invoice</option>
    				<option value="on Summary" '.(($value=='on Summary')? 'selected="selected"':'').'>on Summary</option>
    				<option value="Inv+Summary" '.(($value=='Inv+Summary')? 'selected="selected"':'').'>Inv+Summary</option>    				
    			</select>';    	
    }
    
	protected function __buildOneToseventeenForm($name,$value=null){
		if ( ($name == 'nr_digits') && (is_null($value) || ($value == '-')))
			$value = 17; 
		
    	$selectCode = '<select name="'.$this->_name.'['.$name.']">    
    					 <option value="-">-</option>					  
    				   	 [[options]]
    				   </select>';
    	$optCode = "";
    	for ($i=1;$i<=17;$i++){
    		$selected = "";
    		if ($i==$value)
    			$selected = 'selected = "selected"';	
    		$optCode .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    	}
    	
    	return str_replace ('[[options]]',$optCode,$selectCode);
    }
    
    protected function __buildZeroToNineForm($name,$value=null){
    	
    	$selectCode = '<select name="'.$this->_name.'['.$name.']">
    					  <option value="-">-</option>
    				   	 [[options]]
    				   </select>';
    	$optCode = "";
    	for ($i=1;$i<=9;$i++){
    		$selected = "";
    		if ($i==$value)
    			$selected = 'selected = "selected"';	
    		$optCode .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    	}
    	
    	return str_replace ('[[options]]',$optCode,$selectCode);
    	
    }
    
	protected function __buildMandatorySelect($name,$value = null){
		return '<select name="'.$this->_name.'[mandatory]['.$name.']">
    				<option value="-" '.(($this->_value['mandatory'][$name] == '-') ? 'selected="selected"' : '').'>Mandatory</option>
    				<option value="1" '.(($this->_value['mandatory'][$name] == '1') ? 'selected="selected"' : '').'>several DBI are optional</option>
    				<option value="Y" '.(($this->_value['mandatory'][$name] == 'Y') ? 'selected="selected"' : '').'>DBI is only filled partially</option>
    			</select>';    	
    }
    
 	function getCode(){     
        parent::__buildBaseCode();

        $templateCode = '<table border="0" cellspacing="1" cellpadding="1" style="border:1px solid black;">
        					<tr>
        						<th>ISIcms</th>
        						<th>Renaming</th>
        						<th>Digits</th>
        						<th>Seq.</th>
        						<th>Sorting</th>
        						<th>M/O</th>
        						<th>Subtotal</th>
        					</tr>
        					<tr>
        						<td><b>KS</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ks_renaming]" value="'.$this->_value['ks_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ks_digits',$this->_value['ks_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('ks_sequence',$this->_value['ks_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ks_sorting',$this->_value['ks_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('ks').'</td>
        						<td>'.self::__buildSubtotalForm('ks',$this->_value['subtotal']['ks']).'</td>
        					</tr>
        					<tr>
        						<td><b>PK</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[pk_renaming]" value="'.$this->_value['pk_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('pk_digits',$this->_value['pk_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('pk_sequence',$this->_value['pk_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('pk_sorting',$this->_value['pk_sorting']).'</td>        						
        						<td>'.self::__buildMandatorySelect('pk').'</td>
        						<td>'.self::__buildSubtotalForm('pk',$this->_value['subtotal']['pk']).'</td>
        					</tr>
        					<tr>
        						<td><b>PR</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[pr_renaming]" value="'.$this->_value['pr_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('pr_digits',$this->_value['pr_digits']).'</td>      
        						<td>'.self::__buildZeroToNineForm('pr_sequence',$this->_value['pr_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('pr_sorting',$this->_value['pr_sorting']).'</td>  						
        						<td>'.self::__buildMandatorySelect('pr').'</td>
        						<td>'.self::__buildSubtotalForm('pr',$this->_value['subtotal']['pr']).'</td>
        					</tr>
        					<tr>
        						<td><b>DS</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ds_renaming]" value="'.$this->_value['ds_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ds_digits',$this->_value['ds_digits']).'</td>  
        						<td>'.self::__buildZeroToNineForm('ds_sequence',$this->_value['ds_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ds_sorting',$this->_value['ds_sorting']).'</td>      						
        						<td>'.self::__buildMandatorySelect('ds').'</td>
        						<td>'.self::__buildSubtotalForm('ds',$this->_value['subtotal']['ds']).'</td>
        					</tr>
        					<tr>
        						<td><b>AU</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[au_renaming]" value="'.$this->_value['au_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('au_digits',$this->_value['au_digits']).'</td>        
        						<td>'.self::__buildZeroToNineForm('au_sequence',$this->_value['au_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('au_sorting',$this->_value['au_sorting']).'</td>						
        						<td>'.self::__buildMandatorySelect('au').'</td>
        						<td>'.self::__buildSubtotalForm('au',$this->_value['subtotal']['au']).'</td>
        					</tr>
        					<tr>
        						<td><b>AE</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ae_renaming]" value="'.$this->_value['ae_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ae_digits',$this->_value['ae_digits']).'</td>        
        						<td>'.self::__buildZeroToNineForm('ae_sequence',$this->_value['ae_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ae_sorting',$this->_value['ae_sorting']).'</td>						
        						<td>'.self::__buildMandatorySelect('ae').'</td>
        						<td>'.self::__buildSubtotalForm('ae',$this->_value['subtotal']['ae']).'</td>
        					</tr>
        					<tr>
        						<td><b>BD</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[bd_renaming]" value="'.$this->_value['bd_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('bd_digits',$this->_value['bd_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('bd_sequence',$this->_value['bd_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('bd_sorting',$this->_value['bd_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('bd').'</td>
        						<td>'.self::__buildSubtotalForm('bd',$this->_value['subtotal']['bd']).'</td>
        					</tr>
        					<tr>
        						<td><b>IK</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[ik_renaming]" value="'.$this->_value['ik_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('ik_digits',$this->_value['ik_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('ik_sequence',$this->_value['ik_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('ik_sorting',$this->_value['ik_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('ik').'</td>
        						<td>'.self::__buildSubtotalForm('ik',$this->_value['subtotal']['ik']).'</td>
        					</tr>
        					<tr>
        						<td><b>RZ</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[rz_renaming]" value="'.$this->_value['rz_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('rz_digits',$this->_value['rz_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('rz_sequence',$this->_value['rz_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('rz_sorting',$this->_value['rz_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('rz').'</td>
        						<td>'.self::__buildSubtotalForm('rz',$this->_value['subtotal']['rz']).'</td>
        					</tr>
        					<tr>
        						<td><b>NR(1)</b></td>
        						<td><input type="text" size="20" name="'.$this->_name.'[nr_renaming]" value="'.$this->_value['nr_renaming'].'" /></td></td>
        						<td>'.self::__buildOneToseventeenForm('nr_digits',$this->_value['nr_digits']).'</td>
        						<td>'.self::__buildZeroToNineForm('nr_sequence',$this->_value['nr_sequence']).'</td>
        						<td>'.self::__buildZeroToNineForm('nr_sorting',$this->_value['nr_sorting']).'</td>
        						<td>'.self::__buildMandatorySelect('nr').'</td>
        						<td>'.self::__buildSubtotalForm('nr',$this->_value['subtotal']['nr']).'</td>        						
        					</tr>        					
        				 </table>';		
       	
                       
        
        return $templateCode;
    }
	

}



?>
